/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation
    All rights reserved.

    $Id: CImageView.m,v 1.3 2002/08/06 20:09:17 dallen Exp $
____________________________________________________________________________*/
#import "CImageView.h"

@implementation CImageView

- (void)drawRect:(NSRect)aRect
{
	[super drawRect:aRect];
	if( mOverlayString )
	{
		[NSGraphicsContext saveGraphicsState];
		{
			NSAffineTransform	*transform = [NSAffineTransform transform];
			NSRect				frame,
								savedFrame;
			
			frame = savedFrame = [self frame];
			if( mOverlayAngle )
			{
				frame.origin.x += 30;
				frame.size.width += 100;
				frame.size.height += 100;
				[self setFrame:frame];
				[transform rotateByDegrees:mOverlayAngle];
				[transform concat];
			}
			[mOverlayString drawAtPoint:NSMakePoint(mOverlayAngle ? 30 : 45, 0)];
			[self setFrame:savedFrame];
		}
		[NSGraphicsContext restoreGraphicsState];
	}
}

- (void)setOverlayString:(NSAttributedString *)overlayString rotate:(float)angle
{
	if( mOverlayString )
		[mOverlayString release];
	mOverlayString = overlayString;
	[mOverlayString retain];
	mOverlayAngle = angle;
}

- (void)dealloc
{
	[mOverlayString release];
	[super dealloc];
}

@end

