/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation
    All rights reserved.

    $Id: CKeySelect.h,v 1.10 2002/08/06 20:09:17 dallen Exp $
____________________________________________________________________________*/
#import <PGP/pgpKeys.h>
#import <PGP/pgpTLS.h>
#import "pflPrefs.h"
#import <Cocoa/Cocoa.h>

@class CKeyView;

@interface CKeySelect : NSObject
{
	BOOL						mInited;
	BOOL						mLoadedNib;
    BOOL						mIsSheet;
    
	PGPUInt32					mFlags;

	IBOutlet NSWindow			*mKeySelectWindow;
    IBOutlet id					mKeyView;
    IBOutlet NSButton			*mImportButton;
    IBOutlet NSButton			*mSelectAllButton;
    IBOutlet NSButton			*mSelectNoneButton;
    IBOutlet NSTextField		*mInfoText;
	CKeyView					*mCKeyView;
	PGPPrefRef					mPrefRef;
	PGPKeySetRef				mKeySet;
	PGPKeyDBRef					mMainDB;
	PGPtlsContextRef			mTLSContext;
	id							mOwner;
	SEL							mEndSelector;
	PGPError					mReturnCode;
}
- (id)init;
- (id)initWithNib:(NSString*)nibFile;
- (id)initKeySelect:(NSString *)prompt
		fromSet:(PGPKeySetRef)keySet
		mainDB:(PGPKeyDBRef)mainKeyDB
		prefRef:(PGPPrefRef)prefRef
		usingFlags:(PGPUInt32)flags
		owner:(id)owner
		didEndSelector:(SEL)didEndSelector;
- (void)runKeySelectModalTo:(NSWindow *)window;
- (PGPError)runKeySelectModalDialog:(PGPKeySetRef *)ioSelectedKeys;

- (IBAction)cancelPressed:(id)sender;
- (IBAction)okPressed:(id)sender;
- (IBAction)selectAllPressed:(id)sender;
- (IBAction)selectNonePressed:(id)sender;
- (PGPPrefRef)pgpPrefRef;
- (PGPtlsContextRef)tlsContext;
@end

