/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation
    All rights reserved.

    $Id: CLicense.h,v 1.5 2002/11/15 02:09:16 jeffc Exp $
____________________________________________________________________________*/

#import <Cocoa/Cocoa.h>
#import <PGPclient/pgpClientLibCocoa.h>
#import "pgpLicenseNumber.h"

@interface CLicense : NSObject
{
	PGPContextRef				mContext;
	PGPPrefRef					mPrefRef;
	PGPLicenseNumberRef			mLNRef;
	PGPLicenseAuthorizationRef	mLARef;
	BOOL						mAuthChecked;
	BOOL						mAuthorized;
	BOOL						mInited;
}

- (id)init;
- (id)initWithContext:(PGPContextRef)context;

- (PGPContextRef)context;
- (void)setContext:(PGPContextRef)context;

- (PGPLicenseNumberRef)ln;
- (void)setLN:(PGPLicenseNumberRef)ln;

- (PGPLicenseAuthorizationRef)la;
- (void)setLA:(PGPLicenseNumberRef)la;

- (PGPBoolean)isAuthorized;
- (PGPBoolean)diskEnabled;
- (PGPBoolean)mailEnabled;
- (PGPBoolean)enterpriseEnabled;
- (PGPBoolean)evaluation;
- (PGPBoolean)desktop;
- (PGPUInt8)productID;
- (PGPUInt8)flags;
- (PGPUInt16)evalPeriod;
- (PGPUInt32)numLicenses;
- (PGPUInt32)serialNumber;
- (PGPInt32)daysLeft;
- (PGPError)authorize:(PGPLicenseNumberRef)ln licenseAuth:(PGPLicenseAuthorizationRef)la name:(NSString*)name organization:(NSString*)organization;

- (NSString*)prefName;
- (NSString*)prefOrganization;
- (NSString*)prefLN;
- (NSString*)prefLA;
- (NSString*)getPrefString:(PGPPrefIndex)prefID;

- (void)dealloc;

@end
