/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation
    All rights reserved.

    $Id: CShareholderItem.m,v 1.3 2002/08/06 20:09:17 dallen Exp $
____________________________________________________________________________*/
#import "CShareholderItem.h"
#import <PGP/pgpUtilities.h>

@implementation CShareholderItem

- (id)initPKItem:(PGPKeyDBObjRef)key
{
	[self init];
	mPublicKey = YES;
	mNumShares = 1;
	mPhrase = NULL;
	PGPGetKeyID( key, &mKeyID );
	return self;
}

- (id)initUserItem
{
	[self init];
	mPublicKey = NO;
	mNumShares = 1;
	return self;
}

- (BOOL)isPKItem
{
	return mPublicKey;
}

- (PGPUInt32)numShares
{
	return mNumShares;
}

- (void)keyID:(PGPKeyID *)keyID
{
	if( keyID )
		pgpCopyMemory( &mKeyID, keyID, sizeof( PGPKeyID ) );
}

- (NSString *)name
{
	if( mName )
		[[mName retain] autorelease];
	return mName;
}

- (void)setName:(NSString *)name
{
	if( mName )
		[mName release];
	mName = [[NSString alloc] initWithString:name];
}

- (void)setNumShares:(PGPUInt32)numShares
{
	mNumShares = numShares;
}

- (char *)phrase
{
	return mPhrase;
}

- (void)setPhrase:(char *)phrase
{
	if( mPhrase )
		PGPFreeData( mPhrase );
	mPhrase = phrase;
}

- (void)dealloc
{
	if( mName )
		[mName release];
	if( mPhrase )
		PGPFreeData( mPhrase );
	[super dealloc];
}

@end

