/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation
    All rights reserved.

    $Id: CPGPLicenseDisplay.h,v 1.5 2002/11/22 08:44:36 jeffc Exp $
____________________________________________________________________________*/

#import <Cocoa/Cocoa.h>
#import "PGPConsole.h"
#import "pgpLicenseNumber.h"

@interface CPGPLicenseDisplay : NSObject
{
	IBOutlet NSWindow*			mWindow;
	IBOutlet NSTextField*		mNameLabel;
	IBOutlet NSTextField*		mName;
	IBOutlet NSTextField*		mOrganizationLabel;
	IBOutlet NSTextField*		mOrganization;
	IBOutlet NSTextField*		mLicenseSeatsLabel;
	IBOutlet NSTextField*		mLicenseSeats;
	IBOutlet NSTextField*		mExpirationLabel;
	IBOutlet NSTextField*		mExpiration;
	IBOutlet NSBox*				mProductInfoBox;
	IBOutlet NSMatrix*			mFlagNames;
	IBOutlet NSMatrix*			mFlags;
	IBOutlet NSTextField*		mPurchaseMessage;
	IBOutlet NSButton*			mPurchaseNow;
	IBOutlet NSButton*			mChangeLicense;
	IBOutlet NSButton*			mOK;
	
	BOOL						mInited;
	BOOL						mLoadedNib;
}

+ (CPGPLicenseDisplay*)sharedLicenseDisplay;

- (id)init;
- (void)loadNib:(NSString*)nibFile;

- (NSWindow*)window;

- (void)setupDialog;
- (void)setExpirationDate:(PGPInt32)days flags:(PGPUInt8)flags;
- (void)configureProductInfoBox:(PGPUInt8)flags;
- (void)resetDialog;
- (void)display;

- (IBAction)purchaseNow:(id)sender;
- (IBAction)changeLicense:(id)sender;
- (IBAction)ok:(id)sender;

- (void)dealloc;

@end
