/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation
    All rights reserved.

    $Id: CPGPUninstaller.h,v 1.12 2002/10/03 20:43:44 jeffc Exp $
____________________________________________________________________________*/

#import <Cocoa/Cocoa.h>
#import <Security/Authorization.h>
#import <Security/AuthorizationTags.h>
#import <PGP/PGP.h>
#import <PGPclient/pgpClientLibCocoa.h>
#import <unistd.h>

#define kPGPUninstallerNib			@"PGPUninstaller"
#define kPGPUninstallerLaunchPath	@"installtool"

@interface CPGPUninstaller : NSObject
{
    AuthorizationRef				mAuthRef;
    AuthorizationRights				mRights;
    AuthorizationFlags				mFlags;

	IBOutlet NSWindow*				mUninstallWindow;
    IBOutlet NSImageView*			mUninstallImage;
	IBOutlet NSTextField*			mUninstallText;
	IBOutlet NSProgressIndicator*	mUninstallProgress;
	IBOutlet NSTextField*			mUninstallStatus;
	IBOutlet NSButton*				mCleanUninstall;
	IBOutlet NSTextField*			mCleanText;
	IBOutlet NSButton*				mUninstallButton;
	IBOutlet NSButton*				mAuthButton;
	IBOutlet NSTextField*			mAuthText;

	NSArray*						mInstallInfo;
	NSImage*						mLockImage;
	NSImage*						mUnlockImage;
	NSConditionLock*				mLock;
	PGPError						mUninstallReturnCode;
    PGPUInt32						mStatus;
	BOOL							mBusy;
	BOOL							mFinished;
    BOOL							mThreadDetached;
	BOOL							mLoadedNib;
	BOOL							mInited;
}

- (id)init;
- (id)initWithNib:(NSString*)nibFile;

- (void)setInfo:(NSArray*)info;

- (PGPError)displayUninstaller;

- (BOOL)haveAuthorization;
- (BOOL)obtainAuthorization;
- (void)addUninstallControls;
- (void)removeUninstallControls;
- (PGPUInt32)status;
- (void)setUninstallText:(NSString*)string;
- (void)setUninstallStatus:(NSString*)string;

- (void)uninstallThread;
- (char**)installtoolArguments;

- (IBAction)uninstall:(id)sender;
//- (IBAction)restart:(id)sender;
- (IBAction)quit:(id)sender;
- (IBAction)cont:(id)sender;
- (IBAction)lock:(id)sender;

- (BOOL)windowShouldClose:(id)sender;
- (void)uninstallWarningDidEnd:(NSWindow*)sheet returnCode:(int)returnCode contextInfo:(void*)contextInfo;
- (void)restartWarningDidEnd:(NSWindow*)sheet returnCode:(int)returnCode contextInfo:(void*)contextInfo;

- (void)dealloc;

@end
