/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation
    All rights reserved.

    $Id: PGPInterfaceController.h,v 1.39 2002/09/20 22:43:41 jeffc Exp $
____________________________________________________________________________*/

#import "PGPConsole.h"
#import <PGPclient/CImageButton.h>

#define kPGPInterfaceControllerNib		@"PGP"

#define kPGPAppMainToolbarKey			@"Main"
#define kPGPAppMenuIdentifierKey		@"MenuIdentifier"
#define kPGPAppMenuBundleMenusKey		@"BundleMenus"

@class PGPAppController;

@interface PGPInterfaceController : NSObject
{
	PGPAppController*				mController;
    id <PGPBundle>					mCurrentBundle;

	IBOutlet NSWindow*				mAboutWindow;
	IBOutlet NSMenu*				mMainMenu;
	IBOutlet NSImageView*			mAboutImage;
	IBOutlet NSBox*					mAboutBox;
	IBOutlet NSView*				mAboutLicensed;
	IBOutlet NSView*				mAboutFreeware;
	IBOutlet NSTextField*			mName;
	IBOutlet NSTextField*			mOrganization;
	IBOutlet NSTextField*			mSeats;
	IBOutlet NSTextField*			mExpDate;
	IBOutlet NSView*				mCreditsContainer;
	IBOutlet NSView*				mCreditsView;
	IBOutlet NSClipView*			mClipView;
	IBOutlet NSTextField*			mCreditsText;
	IBOutlet NSTextField*			mVersionText;
	
	NSTimer*						mScrollTimer;
	float							mScrollYPos;
	float							mStartingPoint;
	
	BOOL							mGUIInitialized;
	BOOL							mInited;
	BOOL							mLoadedNib;
}

- (id)init;
- (id)initWithNib:(NSString*)nibFile;
- (id)initWithController:(id)controller;

- (id)controller;
- (void)setController:(id)controller;

- (BOOL)initializeInterface;

- (IBAction)showPreferences:(id)sender;

- (id <PGPBundle>)currentBundle;
- (void)setCurrentBundle:(id <PGPBundle>)controller passive:(BOOL)passive;

- (NSMenu*)mainMenu;
- (NSArray*)menuItems;
- (void)addMenu:(NSMenu*)menu withIdentifier:(NSString*)identifier;
- (void)addMenu:(NSMenu*)menu withIdentifier:(NSString*)identifier atIndex:(unsigned)index;
- (void)addMenuItem:(NSMenuItem*)menuItem withIdentifier:(NSString*)identifier;
- (void)addMenuItem:(NSMenuItem*)menuItem withIdentifier:(NSString*)identifier atIndex:(unsigned)index;
- (void)removeMenusForIdentifier:(NSString*)identifier;
- (void)registerMenuItem:(NSMenuItem*)menuItem withIdentifier:(NSString*)identifier;
- (BOOL)validateMenuItem:(id <NSMenuItem>)menuItem;

- (IBAction)about:(id)sender;
- (IBAction)upgrade:(id)sender;
- (IBAction)license:(id)sender;
- (IBAction)confirmUninstall:(id)sender;
- (IBAction)arrangeInFront:(id)sender;
- (IBAction)quit:(id)sender;
- (IBAction)disk:(id)sender;
- (IBAction)keys:(id)sender;
- (IBAction)net:(id)sender;
- (IBAction)mail:(id)sender;

- (void)uninstallWarningDidEnd:(NSWindow*)sheet returnCode:(int)returnCode contextInfo:(void*)contextInfo;

- (void)createScrollTimer;
- (void)scrollCredits:(NSTimer*)timer;
- (void)windowWillClose:(NSNotification*)notification;

- (void)dealloc;

@end
