/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation
    All rights reserved.

    $Id: PGPPrefsManager.h,v 1.25 2002/08/06 20:09:21 dallen Exp $
____________________________________________________________________________*/

#import "PGPConsole.h"
#import "PGPPrefsController.h"
#import "PGPPrefsGeneral.h"
#import "PGPPrefsAdvanced.h"

#import <PGPclient/pflPrefTypes.h>
#import <PGPclient/CPGPPrefObj.h>

#define kPGPPrefsManagerNib				@"PGPprefs"
#define kPGPPrefsPanelColumnIdentifier	@"Panel"

@interface PGPPrefsManager : NSObject
{
    PGPAppController*		mAppController;
	PGPPrefRef				mPrefRef;
	PGPPrefRef				mNetPrefRef;

    NSMutableDictionary*	mPrefDictionary;
    NSMutableDictionary*	mPrefControllers;
	NSMutableArray*			mControllers;
	NSMutableArray*			mPrefPanels;
	NSView*					mCurrentView;
	NSView*					mCurrentLastKeyView;
	PGPPrefsGeneral*		mGeneralPrefs;
    PGPPrefsAdvanced*		mAdvancedPrefs;
    
    IBOutlet NSWindow*		mWindow;
	IBOutlet NSTableView*	mPanelTable;
	IBOutlet NSBox*			mPanelBox;
    IBOutlet NSButton*		mSaveButton;
    IBOutlet NSButton*		mCancelButton;
    IBOutlet NSButton*		mDefaultButton;
	IBOutlet NSButton*		mRevertButton;
	
    BOOL					mInited;
	BOOL					mLoadedNib;
}

- (id)init;
- (id)initWithNib:(NSString*)nibFile;
- (id)initWithController:(id)controller;

- (id)controller;
- (void)setController:(id)controller;

- (PGPPrefRef)pgpPrefRef;
- (void)setPrefRef:(PGPPrefRef)prefRef;

- (PGPPrefRef)pgpNetPrefRef;
- (void)setNetPrefRef:(PGPPrefRef)prefRef;

- (NSMutableArray*)prefPanels;
- (void)setPrefPanels:(NSArray*)prefPanels;
- (void)sortPrefPanels;

- (PGPError)openPrefs;
- (PGPError)closePrefs;

- (void)initPreferencesPanel;
- (void)showPreferences;
- (void)selectFirstPanel;
- (PGPError)setPrefsView:(NSView*)view;
- (PGPError)setActivePrefs:(NSString*)identifier;

- (PGPError)registerIdentifier:(NSString*)identifier withController:(id)controller;
- (id <PGPPrefsController>)controllerForIdentifier:(NSString*)identifier;

- (IBAction)defaultButtonPressed:(id)sender;
- (IBAction)revertButtonPressed:(id)sender;
- (IBAction)saveButtonPressed:(id)sender;
- (IBAction)cancelButtonPressed:(id)sender;

/* NSTableView delegate methods */
- (void)tableViewSelectionDidChange:(NSNotification*)notification;

/* Methods which qualify us for NSTableDataSource status */
- (int)numberOfRowsInTableView:(NSTableView*)tableView;
- (id)tableView:(NSTableView*)tableView objectValueForTableColumn:(NSTableColumn*)column row:(int)row;

- (void)dealloc;

@end
