/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation
    All rights reserved.

    $Id: CPGPdiskAddUser.h,v 1.11 2002/08/22 08:55:19 jeffc Exp $
____________________________________________________________________________*/

#import <Cocoa/Cocoa.h>

#import "PGPdiskCommon.h"
#import "PGPdiskController.h"
#import "CPGPdiskUsers.h"

#define kPGPdiskAddUserNib			@"PGPdiskAddUser"
#define kPGPdiskAddAdminSuccess		101
#define kPGPdiskAddAdminFailure		100

@class PGPdiskController;

@interface CPGPdiskAddUser : NSObject
{
	PGPdiskController*			mTarget;
	SEL							mAddSelector;
	SEL							mCancelSelector;

	IBOutlet NSWindow*			mAddUserWindow;
	IBOutlet NSBox*				mKeyBox;
	IBOutlet NSImageView*		mKeyIcon;
	IBOutlet NSTextField*		mKeyUserID;
	IBOutlet NSTextField*		mUserName;
	IBOutlet NSTextField*		mUserNameCaption;
	IBOutlet NSPopUpButton*		mAuthenticationType;
	IBOutlet NSButton*			mSelectKeyButton;
	IBOutlet NSButton*			mOKButton;
	IBOutlet NSButton*			mCancelButton;
	IBOutlet NSButton*			mReadOnly;
	
	char*						mAdminPassphrase;
	char*						mPassphrase;
	PGPUInt32					mLastSelectedAuthType;	
	NSImageView*				mKeyImage;
	NSRect						mOriginalUsernameRect;	
	PGPKeyDBObjRef				mKeyDBObj;
	
	BOOL						mInited;
	BOOL						mLoadedNib;
}

+ (id)sharedInstance;

- (id)init;
- (id)initWithNib:(NSString*)nibFile;

- (void)displayForWindow:(NSWindow*)window target:(PGPdiskController*)target adminPassphrase:(char*)passphrase addEndSelector:(SEL)addSelector cancelEndSelector:(SEL)cancelSelector;
- (void)reset;

- (IBAction)authTypeSwitched:(id)sender;
- (IBAction)setPassphrase:(id)sender;
- (IBAction)selectKey:(id)sender;
- (IBAction)ok:(id)sender;
- (IBAction)cancel:(id)sender;

- (void)callEndSelector:(SEL)selector;
- (void)keySelectDidEnd:(PGPError)resultCode selectedKeys:(PGPKeySetRef)keySet;
- (void)textDidChange:(NSNotification*)notification;

- (void)dealloc;

@end
