/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation
    All rights reserved.

    $Id: CPGPdiskDiskTable.h,v 1.9 2002/08/06 20:09:29 dallen Exp $
____________________________________________________________________________*/

#import <Cocoa/Cocoa.h>
#import <PGPclient/pgpClientLibCocoa.h>

#define kPGPdiskDiskCellIcon		@"pgpdisk-doc.icns"
#define kPGPdiskOS9DiskCellIcon		@"smdiskdoc"

@class PGPdiskController, CPGPdiskObject;

@interface CPGPdiskDiskTable : NSObject
{
	PGPdiskController*	mController;

	NSTableView*		mDiskTable;
	NSImage*			mDiskCellIcon;
	NSImage*			mOS9DiskCellIcon;
	float				mColumnSize;
    PGPBoolean			mHideExtensions;
	CPGPdiskObject*		mLastSelectedDisk;
    
	BOOL				mInited;
}

- (id)init;
- (id)initWithController:(PGPdiskController*)controller;

- (id)table;
- (void)setTable:(id)table;

- (void)orderListByAscendingOrder:(BOOL)flag;

/* NSTableView delegate methods */
- (BOOL)tableView:(NSTableView*)tableView shouldSelectRow:(int)row;
- (void)tableViewSelectionDidChange:(NSNotification*)notification;
- (void)tableView:(NSTableView*)table willDisplayCell:(id)cell forTableColumn:(NSTableColumn*)column row:(int)row;

/* Methods which qualify us for NSTableDataSource status */
- (int)numberOfRowsInTableView:(NSTableView*)tableView;
- (id)tableView:(NSTableView*)tableView objectValueForTableColumn:(NSTableColumn*)column row:(int)row;

- (NSDragOperation)tableView:(NSTableView*)table validateDrop:(id <NSDraggingInfo>)info proposedRow:(int)row proposedDropOperation:(NSTableViewDropOperation)operation;

- (BOOL)tableView:(NSTableView*)table acceptDrop:(id <NSDraggingInfo>)info row:(int)row dropOperation:(NSTableViewDropOperation)operation;

- (void)dealloc;

@end
