/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation
    All rights reserved.

    $Id: CPGPdiskProgressPanel.h,v 1.4 2002/08/06 20:09:29 dallen Exp $
____________________________________________________________________________*/

#import <PGP/PGP.h>
#import <Cocoa/Cocoa.h>

#define kPGPdiskProgressPanelNib		@"PGPdiskProgressPanel"

@interface CPGPdiskProgressPanel : NSObject
{
	IBOutlet NSWindow*				mWindow;
	IBOutlet NSTextField*			mCaption;
	IBOutlet NSProgressIndicator*	mProgressIndicator;
	IBOutlet NSButton*				mStop;
    
    id								mDelegate;
    SEL								mEndSelector;
    SEL								mStopSelector;
	void*							mContextInfo;

	BOOL							mInited;
	BOOL							mLoadedNib;
}

+ (id)sharedPanel;

- (id)init;
- (id)initWithNib:(NSString*)nibFile;

- (NSString*)caption;
- (void)setCaption:(NSString*)caption;

- (NSWindow*)window;
- (NSProgressIndicator*)progressIndicator;

- (void)runSheetModalToWindow:(NSWindow*)window modalDelegate:(id)delegate didEndSelector:(SEL)endSelector stopSelector:(SEL)stopSelector contextInfo:(void*)contextInfo;
- (void)endSheetWithReturnCode:(PGPError)returnCode;

- (IBAction)stop:(id)sender;

- (void)sheetDidEnd:(NSWindow*)sheet returnCode:(int)returnCode contextInfo:(void*)contextInfo;
- (void)close;
- (void)dealloc;

@end
