/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation
    All rights reserved.

    $Id: CPGPdiskReEncryption.h,v 1.3 2002/11/09 03:05:39 jeffc Exp $
____________________________________________________________________________*/

#import <Cocoa/Cocoa.h>
#import "PGPdiskCommon.h"
#import "pgpDiskEngine.h"

@protocol CPGPdiskReEncryptionClient

- (void)completedReEncryptionOfDisk:(NSString*)filename;
- (void)failedToReEncryptDisk:(NSString*)filename;

@end

@interface CPGPdiskReEncryption : NSObject
{
	PGPdiskDiskRef				mDiskRef;
	PGPdiskEncryptionAlgorithm	mAlgorithm;
	NSString*					mDiskPath;
	NSData*						mPassphrase;
	NSConnection*				mConnection;
	
	char						mPubRingPath[PATH_MAX];
	char						mSecRingPath[PATH_MAX];
	BOOL						mInited;
}

- (id)init;

- (void)setAlgorithm:(PGPdiskEncryptionAlgorithm)algorithm;
- (void)setDiskPath:(NSString*)path;
- (void)setPassphrase:(NSData*)passphrase;
- (void)setServerConnection:(NSConnection*)connection;
- (void)setPubRingPath:(char*)pubPath;
- (void)setSecRingPath:(char*)secPath;

- (void)reEncryptDiskWithPorts:(NSArray*)ports;
- (void)abortReEncryption;

- (void)dealloc;

@end
