/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation
    All rights reserved.

    $Id: CPGPdiskUsers.h,v 1.9 2002/09/26 21:57:37 jeffc Exp $
____________________________________________________________________________*/

#import <Cocoa/Cocoa.h>

#import "PGPdiskCommon.h"
#import "PGPdiskController.h"	/* Imported for our category "PGPdiskUserExtensions" */
#import "CPGPdiskAddUser.h"

@interface CPGPdiskUser : NSObject
{
	PGPdiskUserRef				mUserRef;
	
	NSString*					mName;
	
	BOOL						mHasPublicKey;
	BOOL						mHasSymmetricKey;
	BOOL						mIsReadOnly;
	BOOL						mIsLocked;
	BOOL						mIsAdminUser;
	BOOL						mIsDisabled;
	BOOL						mCanSetReadOnly;
	BOOL						mCanSetLocked;
	BOOL						mCanSetUserName;
	
	BOOL						mInited;
}

+ (PGPdiskUserRef)findAdminInUserSet:(PGPdiskUserSetRef)userSet;
+ (PGPdiskUserRef)findUser:(PGPdiskUserRef)userRef inUserSet:(PGPdiskUserSetRef)userSet;
+ (PGPdiskUserRef)findUserAtIndex:(int)index inUserSet:(PGPdiskUserSetRef)userSet;

- (id)initWithUserRef:(PGPdiskUserRef)userRef;

- (void)updateProperties;

- (NSString*)name;
- (void)setName:(NSString*)name;

- (PGPdiskUserRef)userRef;
- (void)setUserRef:(PGPdiskUserRef)userRef;

- (BOOL)isAdmin;
- (BOOL)isReadOnly;
- (BOOL)isSymmetricKeyUser;
- (BOOL)isPublicKeyUser;
- (BOOL)isDisabled;

- (void)dealloc;

@end