/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation
    All rights reserved.

    $Id: PGPdiskPreferences.h,v 1.18 2002/09/30 08:21:15 jeffc Exp $
____________________________________________________________________________*/

#import <Cocoa/Cocoa.h>
#import <PGPclient/pgpClientLibCocoa.h>
#import <PGPclient/CIntegerFormatter.h>
#import <PGPclient/pgpClientPrefs.h>
#import <PGPclient/CPGPPrefObj.h>

#import "PGPdiskCommon.h"
#import "PGPBundle.h"
#import "PGPPrefsController.h"
#import "PGPdiskController.h"

#define kPGPdiskPreferencesNib			@"PGPdiskPreferences"
#define kPGPdiskPrefsIdentifier			LSPD(@"PGPdisk", @"PGPdisk Pref Panel")

@class NSDictionary, NSMutableDictionary;

@interface PGPdiskPreferences : NSObject <PGPPrefsController>
{
	PGPdiskController*		mController;
	NSArray*				mIdentifiers;

	IBOutlet NSView*		mPrefsView;
	IBOutlet NSButton*		mAllowForcibleUnmounts;
	IBOutlet NSButton*		mAutoUnmountAfterDelay;
	IBOutlet NSButton*		mAutoUnmountDelay;
	IBOutlet NSStepper*		mDelayStepper;
    IBOutlet NSButton*		mUnmountOnSleep;
	IBOutlet NSButton*		mPreventSleep;
	
	BOOL					mInited;
	BOOL					mLoadedNib;
}

- (id)init;
- (id)initWithNib:(NSString*)nibFile;
- (id)initWithController:(id)controller;

- (id)controller;
- (NSArray*)identifiers;
- (id)prefsViewForIdentifier:(NSString*)identifier;

- (id)firstPrefsResponderForIdentifier:(NSString*)identifier;
- (id)lastPrefsResponderForIdentifier:(NSString*)identifier;
- (void)setupKeyViewLoopForIdentifier:(NSString*)identifier;

- (void)restorePanelPrefs:(NSString*)panelIdentifier;
- (void)restorePanelDefaults:(NSString*)panelIdentifier;
- (void)savePanelPrefs:(NSString*)panelIdentifier;

- (void)setAllowForcibleUnmount:(PGPBoolean)value enabled:(BOOL)enabled;
- (void)setUnmountOnInactivity:(PGPBoolean)value enabled:(BOOL)enabled;
- (void)setAutoUnmountTimeout:(PGPUInt32)value enabled:(BOOL)enabled;
- (void)setUnmountOnSleep:(PGPBoolean)value enabled:(BOOL)enabled;
- (void)setPreventSleep:(PGPBoolean)value enabled:(BOOL)enabled;

- (PGPBoolean)getAllowForcibleUnmount;
- (PGPBoolean)getUnmountOnInactivity;
- (PGPUInt32)getAutoUnmountTimeout;
- (PGPBoolean)getUnmountOnSleep;
- (PGPBoolean)getPreventSleep;

- (void)setCheckbox:(NSButton*)checkBox state:(BOOL)state enabled:(BOOL)enabled;
- (PGPBoolean)getCheckbox:(NSButton*)checkBox;

- (IBAction)unmountAfterDelay:(id)sender;
- (IBAction)unmountOnSleep:(id)sender;
- (IBAction)stepperPressed:(id)sender;

@end
