/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.

	$Id: PGPdiskControllerUserClient.h,v 1.6 2002/08/06 20:09:34 dallen Exp $
____________________________________________________________________________*/
#pragma once

enum PGPdiskControllerUserClientCmdCodes
{
	kPGPdiskControllerUserClient_CreateDisk,
	kPGPdiskControllerUserClient_NumCommands
};

#define kPGPdiskController_ClassName 			"PGPdiskController"
#define kPGPdiskControllerUserClient_ClassName 	"PGPdiskControllerUserClient"
#define kPGPdiskController_IconPathMaxLength	512

typedef struct PGPdiskCreateDiskParams
{
	UInt64			diskSizeBytes;
	char			mountReadOnly;	// boolean
	char			ejectOnLogout;	// boolean
	char			autoDiskMount;	// boolean
	char			iconPath[kPGPdiskController_IconPathMaxLength];
} PGPdiskCreateDiskParams;

#if KERNEL

#include <mach/mach_types.h>
#include <IOKit/IOUserClient.h>

class PGPdiskController;
class PGPdiskControllerUserClient : public IOUserClient
{
	OSDeclareDefaultStructors(PGPdiskControllerUserClient)
	
public:
	virtual bool				initWithTask( task_t owningTask, void *securityToken, UInt32 type );
	virtual bool				start( IOService *provider );
	virtual void				free( void );
	virtual IOExternalMethod	*getTargetAndMethodForIndex( IOService **target, UInt32 index );
	virtual IOReturn			clientClose( void );
	virtual IOReturn 			message(UInt32 type, IOService * provider, void * argument);

protected:
	IOExternalMethod			sMethods[ kPGPdiskControllerUserClient_NumCommands ];
	
	task_t						fClient;
	PGPdiskController			*fService;
};

#endif /* KERNEL */

