/*____________________________________________________________________________
		Copyright (C) 2002 PGP Corporation
        All rights reserved.

        $Id: CDriverComm.h,v 1.4 2002/08/06 20:09:36 dallen Exp $
____________________________________________________________________________*/

#ifndef Included_CDriverComm_h	// [
#define Included_CDriverComm_h

#include "pgpDiskPubTypes.h"

#include "CSubsystem.h"
#include "CEngineImpFactory.h"

_PGP_BEGIN

// Types

class CString;


// Class CDriverComm

class CDriverComm : public CSubsystem
{
	DECLARE_IMPHOST(CDriverComm)
	friend class CEngineSubsystems;

public:
	PGPBoolean	IsDriverOpened() const;
	
	void	QueryVersion(PGPUInt32& driverApiVersion) const;
	void	QueryMountedPath(const char *path, PGPBoolean& isMounted) const;
	void	QueryMountedRoot(const char *root, PGPBoolean& isMounted) const;
	void	QueryAllMounted(PGPdiskInfo *pInfoArray, PGPUInt32 elemsArray, 
		PGPUInt32& elemsFilled) const;

	void	NotifyUserLogoff() const;

	void		SetTimeout(const char *root, PGPUInt32 seconds) const;
	PGPBoolean	AreDisksTimedOut() const;
	void		ResetTimedOutDisk(const char *root) const;
	
	void	Mount(const char *path, const char *root, 
		PGPdiskEncryptionAlgorithm algorithm, const void *exportedContext, 
		PGPUInt32 sizeContext, PGPUInt64 firstDataBlock, 
		PGPUInt64 numDataBlocks, CString& deviceName, 
		PGPBoolean readOnly = FALSE) const;
	void	Unmount(const char *root, PGPBoolean isForced) const;

	PGPUInt32	LockVolume(const char *root, PGPBoolean forFormat) const;
	void		UnlockVolume(PGPUInt32 handle) const;
	void		IOVolume(PGPUInt32 handle, PGPBoolean trueIfRead, 
		void *buffer, PGPUInt64 blockPos, PGPUInt32 blocksLength) const;

protected:
	void	Startup();
	void	Shutdown();
};

_PGP_END

#endif	// Included_CDriverComm_h
