/*____________________________________________________________________________
		Copyright (C) 2002 PGP Corporation
        All rights reserved.

        $Id: CPGPdiskContext.h,v 1.9 2002/08/06 20:09:36 dallen Exp $
____________________________________________________________________________*/

#ifndef Included_CPGPdiskContext_h	// [
#define Included_CPGPdiskContext_h

#include "CPGPclPrefs.h"
#include "CPGPContext.h"
#include "CPGPKeyDB.h"

_PGP_BEGIN

// Types

class CPGPKey;
class CPGPdiskDiskSet;


// Class CPGPdiskContext

class CPGPdiskContext
{
	NOT_COPYABLE(CPGPdiskContext)
	friend class CPGPdiskDiskSet;

public:
	CPGPdiskContext();
	~CPGPdiskContext() { }

	const CPGPclPrefs&	PGPclPrefs() const;
	const CPGPContext&	PGPContext() const {return mPGPContext;}
	const CPGPKeyDB&	PGPKeyDB() const;

	PGPBoolean	IsTherePGPdiskADK() const;

	void	GetPGPdiskADKPubKey(CPGPKey& adkKey) const;
	void	GetPGPdiskADKUserID(CString& userID) const;

	void	UpdateDiskSet(CPGPdiskDiskSet& diskSet) const;
	void	ReloadPGPKeyDB() const;
	mutable PGPBoolean	mKeyDBModified;	

private:
	CPGPContext			mPGPContext;
	mutable CPGPclPrefs	mPGPclPrefs;
	mutable CPGPKeyDB	mPGPKeyDB;
};

_PGP_END

#endif	// ] Included_CPGPdiskContext_h
