/*____________________________________________________________________________
		Copyright (C) 2002 PGP Corporation
        All rights reserved.

        $Id: PGPdiskOldCrypto.h,v 1.4 2002/08/06 20:09:36 dallen Exp $
____________________________________________________________________________*/

#ifndef Included_PGPdiskOldCrypto_h	//
#define Included_PGPdiskOldCrypto_h

_PGP_BEGIN

// Align to 1.
#if PGP_WIN32
#pragma pack(push, 1)
#endif

namespace PGPdiskOldCrypto
{
	// Types

	union SymmetricKey 
	{
		PGPUInt8	bytes[16];
		PGPUInt32	dwords[16/sizeof(PGPUInt32)];
	};

	typedef SymmetricKey EncryptedKey;

	union ExpandedKey 
	{
		PGPUInt8	bytes[128];
		PGPUInt32	dwords[128/sizeof(PGPUInt32)];
	};

	struct CheckBytes 
	{
		PGPUInt8 bytes[8];
	};

	union PassphraseSalt
	{
		PGPUInt8	bytes[8];
		PGPUInt32	dwords[8/sizeof(PGPUInt32)];
	};

	struct PassphraseKeyInfo 
	{
		EncryptedKey	encryptedKey;
		CheckBytes		checkBytes;
		PGPUInt16		hashReps;		// # of hashes on passphrase
		PGPUInt16		inUse		: 1;
		PGPUInt16		readOnly	: 1;
		PGPUInt16		unused		: 14;
		PGPUInt32		unusedLong;
	};
}

// Restore alignment.
#if PGP_WIN32
#pragma pack(pop)
#endif

_PGP_END

#endif	// Included_PGPdiskOldCrypto_h
