/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation
    All rights reserved.

    $Id: CKeySign.h,v 1.8 2002/08/06 20:09:45 dallen Exp $
____________________________________________________________________________*/
#import <PGP/pgpKeys.h>
#import <PGPclient/PGPOpenPrefs.h>
#import <Cocoa/Cocoa.h>

@protocol PGPKeySign
- (PGPPrefRef)pgpPrefRef;
- (void)endKeySign:(id)keysView success:(BOOL)signedKeys;
@end

@interface CKeySign : NSObject
{
	id <PGPKeySign>			mOwnerController;
	BOOL					mInited;
	BOOL					mLoadedNib;
	IBOutlet NSWindow		*mSignWindow;
    IBOutlet NSView			*mChoicesView;
    IBOutlet NSView			*mFewerChoicesView;
    IBOutlet NSView			*mMoreChoicesView;
    IBOutlet NSTextField	*mDomainRestrictionField;
    IBOutlet NSTextField	*mExpirationDateField;
    IBOutlet NSTextField	*mTrustDepthField;
    IBOutlet NSMatrix		*mExpirationMatrix;
    IBOutlet NSMatrix		*mSigTypeMatrix;
    IBOutlet NSButton		*mExportableCheckbox;
    IBOutlet NSButton		*mDisclosureButton;
    IBOutlet NSStepperCell	*mTrustDepthStepper;
    IBOutlet NSTableView	*mUserIDTableView;
    IBOutlet NSImageView	*mEImage;
    IBOutlet NSImageView	*mMINEImage;
    IBOutlet NSImageView	*mNEImage;
    IBOutlet NSImageView	*mTINEImage;
	BOOL					mFewerMode;
	BOOL					mSignedKeys;
	NSMutableArray			*mUserIDArray;
	PGPKeyDBRef				mKeyDB;
	PGPKeyDBObjRef			mDefaultSigner;
	id						mKeysView;
}
- (id)init;
- (id)initWithController:(id)controller keysView:(id)keysView forArray:(NSMutableArray *)userIDArray
		forKeyDB:(PGPKeyDBRef)keyDB defaultSigner:(PGPKeyDBObjRef)signer;
- (id)initWithNib:(NSString*)nibFile;
- (NSWindow *)window;
- (IBAction)keySignAction:(id)sender;
- (IBAction)sigTypeChanged:(id)sender;
- (IBAction)toggleChoices:(id)sender;
@end

