/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation
    All rights reserved.

    $Id: CKeySplit.h,v 1.6 2002/08/06 20:09:45 dallen Exp $
____________________________________________________________________________*/
#import <PGP/pgpKeys.h>
#import <PGP/pgpTLS.h>
#import <PGPclient/PGPOpenPrefs.h>
#import <Cocoa/Cocoa.h>

@protocol PGPKeySplit
- (PGPPrefRef)pgpPrefRef;
- (PGPtlsContextRef)tlsContext;
- (void)endKeySplit:(id)keysView success:(BOOL)split;
@end

@interface CKeySplit : NSObject
{
    IBOutlet NSButton			*mAddButton;
    IBOutlet NSButton			*mRemoveButton;
    IBOutlet NSTextField		*mSharePathField;
    IBOutlet NSTableView		*mShareTableView;
    IBOutlet NSButton			*mSplitKeyButton;
    IBOutlet NSTextField		*mSplitKeyField;
    IBOutlet NSImageView		*mSplitKeyImage;
    IBOutlet NSWindow			*mSplitKeyWindow;
    IBOutlet NSTextField		*mThresholdField;
    IBOutlet NSTextField		*mTotalSharesField;
	IBOutlet NSStepper			*mTotalSharesStepper;
	IBOutlet NSNumberFormatter	*mShareFormatter;

	id <PGPKeySplit>			mController;
	id							mKeysView;
	BOOL						mInited;
	BOOL						mLoadedNib;
	BOOL						mSplit;
	PGPKeyDBRef					mKeyDB;
	PGPKeyID					mKeyID;
	PGPKeyDBObjRef				mSplitKey;
	NSMutableArray				*mShareArray;
	NSImage						*mUserImage;
	int							mAddedCount;
}
- (id)initWithNib:(NSString*)nibFile;
- (id)initWithController:(id)controller keysView:(id)keysView splitKey:(PGPKeyDBObjRef)splitKey;
- (IBAction)dialogButtonPressed:(id)sender;
- (IBAction)browseButtonPressed:(id)sender;
- (IBAction)addButtonPressed:(id)sender;
- (IBAction)removeButtonPressed:(id)sender;
- (IBAction)selectionChanged:(id)sender;
- (NSWindow *)window;
@end

