/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation
    All rights reserved.

    $Id: CPGPkeysView.h,v 1.23 2002/11/11 21:41:42 jeffc Exp $
____________________________________________________________________________*/
#import <PGPclient/CKeyView.h>
#import <PGPclient/CCAThread.h>
#import <PGPclient/pgpClientLibCocoa.h>

@protocol PGPKeysView
- (void)newKey:(id)keysView;
- (void)sign:(id)keysView forArray:(NSMutableArray *)userIDArray;
- (void)search:(id)keysView;
- (void)split:(id)keysView forKey:(PGPKeyDBObjRef)splitKey;
- (PGPContextRef)pgpContext;
- (PGPtlsContextRef)tlsContext;
- (PGPPrefRef)pgpPrefRef;
- (PGPKeyDBRef)mainDB;
@end

@interface CPGPkeysView : NSObject <PGPKeyView>
{
    IBOutlet NSView				*mPGPkeysView;
	IBOutlet NSView				*mKeyView;
	
	IBOutlet NSView				*mSavePanelAuxView;
	IBOutlet NSButton			*mInclude6XCheckbox;
	IBOutlet NSButton			*mIncludePrivatesCheckbox;
	
	IBOutlet NSWindow			*mAddNameWindow;
	IBOutlet NSTextField		*mAddNameNameField;
	IBOutlet NSTextField		*mAddNameEmailField;
	IBOutlet NSButton			*mAddNameOKButton;
	
	IBOutlet NSWindow			*mAddPhotoWindow;
	IBOutlet NSImageView		*mAddPhotoImageView;
	
	IBOutlet NSButton			*mProgressCancelButton;
	IBOutlet NSWindow			*mProgressWindow;
	IBOutlet NSProgressIndicator*mProgressProgressIndicator;
	IBOutlet NSTextField		*mProgressStatusField;
	BOOL						mProgressAbort;
	
	BOOL						mInited;
	BOOL						mLoadedNib;
	id <PGPKeysView>			mController;
	PGPContextRef				mPGPContext;
	PGPtlsContextRef			mTLSContext;
	PGPPrefRef					mPrefRef;
	
	NSToolbar					*mToolbar;
	NSToolbarItem				*mToolbarItemNew;
	NSToolbarItem				*mToolbarItemRevoke;
	NSToolbarItem				*mToolbarItemSign;
	NSToolbarItem				*mToolbarItemDelete;
	NSToolbarItem				*mToolbarItemSearch;
	NSToolbarItem				*mToolbarItemSendToServer;
	NSToolbarItem				*mToolbarItemUpdate;
	NSToolbarItem				*mToolbarItemShowInfo;
	NSToolbarItem				*mToolbarItemImport;
	NSToolbarItem				*mToolbarItemExport;
	
	CKeyView					*mCKeyView;
	BOOL						mIsMainDB;
	BOOL						mSearch;
	PGPKeyDBRef					mKeyDB;
	PGPKeyDBObjRef				mFirstSelection;
	BOOL						mMultipleSelected;
	PGPUInt32					mSelectFlags;
	NSResponder*				mLastKeyView;
	
	PGPCAOp						mCAOp;
	PGPKeyDBObjRef				mCATargetKey;
	PGPKeyDBObjRef				mCATargetUser;
	PGPUInt32					mCARequestType;
	PGPKeyServerEntry			*mTargetServer;
}

- (id)init;
- (id)initWithController:(id)controller mainDB:(BOOL)isMainDB search:(BOOL)search;
- (id)initWithNib:(NSString*)nibFile;

- (NSView *)view;
- (NSView *)keyView;
- (NSOutlineView *)outlineView;
- (NSWindow *)window;
- (void)setupToolbar;
- (void)loadKeys:(PGPKeyDBRef)keyDB showKeySet:(PGPKeySetRef)keySet;
- (void)emptyKeys;
- (void)setActive:(BOOL)flag;
- (void)keysMenuAction:(id)sender;
- (void)toggleColumn:(PGPInt16)columnIndex;
- (BOOL)validateCommand:(int)command item:(NSMenuItem *)menuItem;
- (BOOL)validateToolbarItem:(NSToolbarItem*)item;
- (void)reload;
- (PGPKeyDBObjRef)lookupDefaultKey;
- (PGPKeyDBRef)keyDB;
- (PGPKeyDBRef)mainDB;
- (IBAction)addNameAction:(id)sender;
- (IBAction)addPhotoAction:(id)sender;
- (IBAction)progressCancelAction:(id)sender;
- (void)importDocument:(NSString *)docFile;
- (PGPKeySetRef)getSelectedKeySet;

- (BOOL)columnIsActive:(PGPInt16) columnIndex;
- (void)selectionChanged;

- (void)setupKeyViewLoop;
- (BOOL)keyViewIsValid:(NSResponder*)keyView;

- (PGPContextRef)pgpContext;
- (PGPtlsContextRef)tlsContext;
- (PGPPrefRef)pgpPrefRef;

- (PGPError)sendKeyDBObj:(PGPKeyDBObjRef)keyDBObj;
- (PGPError)updateKeyDBObj:(CKeyDBItem*)keyItem atomic:(BOOL)atomic;
- (void)sendSelection;
- (void)updateSelection;
- (void)updateKeys:(NSDictionary*)info;
- (void)updateMainKeyDBWithKeys:(NSDictionary*)info;

- (NSToolbarItem*)toolbar:(NSToolbar*)toolbar itemForItemIdentifier:(NSString*)identifier willBeInsertedIntoToolbar:(BOOL)flag;
- (NSArray*)toolbarAllowedItemIdentifiers:(NSToolbar*)toolbar;
- (NSArray*)toolbarDefaultItemIdentifiers:(NSToolbar*)toolbar;

- (void)dealloc;

@end

