/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation
    All rights reserved.

    $Id: PGPkeysController.h,v 1.51 2002/10/08 02:21:01 jeffc Exp $
____________________________________________________________________________*/
#import "PGPkeysCommon.h"
#import "PGPBundleKeys.h"
#import "PGPController.h"
#import <PGPclient/CImageButton.h>

@class PGPkeysPreferences, CKeySign, CKeyGen, CKeySearch, CKeySplit, CPGPkeysView;
@class CSendShares, CKeyring;

@interface PGPkeysController : NSObject <PGPBundle, PGPBundleKeys>
{
	IBOutlet NSWindow			*mWindow;
	IBOutlet NSView				*mMainDBView;
	IBOutlet NSMenu				*mKeysMenu;
	IBOutlet NSMenu				*mServerMenu;
	
	NSMenuItem					*mKeysItemNew;
		
	BOOL						mInited;
	BOOL						mLoadedNib;
	id <PGPController>			mController;
	
	PGPkeysPreferences*			mPGPKeysPreferences;
	PGPContextRef				mPGPContext;
	PGPtlsContextRef			mTLSContext;
	PGPPrefRef					mPrefRef;

	CPGPkeysView				*mMainDBPGPkeysView;
	CKeySign					*mCKeySign;
	CKeyGen						*mCKeyGen;
	CKeySearch					*mCKeySearch;
	CKeySplit					*mCKeySplit;
	CSendShares					*mCSendShares;
	NSMutableArray				*mCKeyrings;
}

+ (NSString*)identifier;

- (id)init;
- (id)initWithController:(id)controller;
- (id)initWithNib:(NSString*)nibFile;

- (id)prefsController;
- (NSWindow*)window;
- (NSImage*)menuImage;
- (NSMenu*)dockMenu;
- (NSMenuItem*)newMenuItem;
- (void)registerForPrefNotifications;
- (BOOL)releaseIfReadyToShutdown;
- (void)keyDBChanged;
- (void)passphraseCacheChanged;
- (void)toggleColumnSelection:(id)sender;
- (void)keysMenuAction:(id)sender;
- (void)newKeyring:(id)sender;
- (void)newKey:(CPGPkeysView *)keysView;
- (void)sign:(CPGPkeysView *)keysView forArray:(NSMutableArray *)userIDArray;
- (void)split:(id)keysView forKey:(PGPKeyDBObjRef)splitKey;
- (void)search:(CPGPkeysView *)keysView;
- (void)sendSharesClosed;
- (void)keyringClosed:(CKeyring *)keyring;
- (BOOL)validateMenuItem:(NSMenuItem *)menuItem;
- (CPGPkeysView *)frontKeyView;
- (void)closeAuxWindows;

- (void)activate:(BOOL)passive;
- (void)deactivate;
- (void)addMenus;
- (void)removeMenus;
- (void)handleDocument:(NSString*)docFile ofType:(NSString*)docType;

- (id)controller;
- (void)setController:(id)controller;
- (PGPContextRef)pgpContext;
- (PGPtlsContextRef)tlsContext;
- (PGPPrefRef)pgpPrefRef;
- (PGPKeyDBRef)mainDB;
- (BOOL)updateKeyrings;
- (void)updateServerMenu;
- (void)serversDidChange:(NSNotification*)notification;

- (void)windowDidBecomeKey:(NSNotification*)notification;
- (BOOL)windowShouldClose:(id)sender;

- (void)dealloc;

@end

