/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation
    All rights reserved.

    $Id: CPGPmailButton.h,v 1.2 2002/08/30 21:30:22 jeffc Exp $
____________________________________________________________________________*/

#import <Cocoa/Cocoa.h>

@interface CPGPmailButton : NSButton
{
	NSMutableArray*			mSupportedFileExtensions;
	NSMutableArray*			mSupportedFileTypes;
	
	SEL						mDragSelector;
	BOOL					mInited;
}

- (id)init;

- (void)setSupportedFileExtensions:(NSArray*)fileExtensions;
- (NSArray*)supportedFileExtensions;

- (void)setSupportedFileTypes:(NSArray*)fileTypes;
- (NSArray*)supportedFileTypes;

- (void)setDragSelector:(SEL)selector;
- (SEL)dragSelector;

- (void)concludeDragOperation:(id <NSDraggingInfo>)sender;
- (NSDragOperation)draggingEntered:(id <NSDraggingInfo>)sender;
- (void)draggingExited:(id <NSDraggingInfo>)sender;

- (BOOL)prepareForDragOperation:(id <NSDraggingInfo>)sender;
- (BOOL)performDragOperation:(id <NSDraggingInfo>)sender;

- (void)awakeFromNib;

- (void)dealloc;

@end
