/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation
    All rights reserved.

    $Id: CPGPmailProgress.h,v 1.7 2002/10/22 09:25:50 jeffc Exp $
____________________________________________________________________________*/
#ifndef Included_CPGPmailProgress_h	/* [ */
#define Included_CPGPmailProgress_h

#import "PGPmailCommon.h"
#import <Cocoa/Cocoa.h>

@interface CPGPmailProgressJob : NSObject
{
	NSLock*				mLock;
	NSString*			mFile;
	PGPmailOperation	mOperation;
	id					mTarget;
	SEL					mSelector;
	
	BOOL				mInited;
}

- (id)init;
- (id)initWithFile:(NSString*)file operation:(PGPmailOperation)operation selector:(SEL)selector target:(id)target;

- (void)lock;
- (void)unlock;

- (NSString*)file;
- (void)setFile:(NSString*)file;

- (PGPmailOperation)operation;
- (void)setOperation:(PGPmailOperation)operation;

- (SEL)selector;
- (void)setSelector:(SEL)selector;

- (id)target;
- (void)setTarget:(id)target;

- (void)dealloc;

@end

@interface CPGPmailProgress : NSObject
{
    IBOutlet NSPanel*				mProgressWindow;
	IBOutlet NSView*				mProgressView;
    IBOutlet NSTextField*			mFileNameText;
    IBOutlet NSTextField*			mMessageText;
    IBOutlet NSProgressIndicator*	mProgressIndicator;
    IBOutlet NSButton*				mStopButton;
    IBOutlet NSImageView*			mBundleIcon;
	IBOutlet NSButton*				mPendingButton;
	IBOutlet NSTextField*			mPendingOpsText;
    
	NSImage*						mEncryptImage;
	NSImage*						mSignImage;
	NSImage*						mEncryptSignImage;
	NSImage*						mDecryptVerifyImage;
	NSImage*						mWipeImage;
	NSImage*						mCollapsed;
	NSImage*						mExpanded;
	NSView*							mPendingView;
	NSMutableArray*					mPendingJobs;
	NSLock*							mLock;
    id								mDelegate;
    SEL								mEndSelector;
    SEL								mStopSelector;
    
    BOOL							mInited;
	BOOL							mLoadedNib;

}

+ (id)sharedInstance;

- (id)init;
- (void)loadNib:(NSString*)nibFile;

- (NSString*)fileName;
- (void)setFileName:(NSString*)fileName;

- (NSString*)message;
- (void)setMessage:(NSString*)message;

- (NSView*)pendingView;
- (void)setPendingView:(NSView*)pendingView;

- (BOOL)jobsPending;

- (void)startProgressForJob:(CPGPmailProgressJob*)job;
- (void)updateProgressForJob:(CPGPmailProgressJob*)job;
- (void)finishedJob:(CPGPmailProgressJob*)job;
- (void)addPendingJob:(CPGPmailProgressJob*)job;
- (void)updateDialog;

- (IBAction)expandCollapsePending:(id)sender;
- (IBAction)stopRequested:(id)sender;
- (IBAction)cancelPendingJob:(id)sender;

- (NSView*)viewForPendingJob:(CPGPmailProgressJob*)job;
- (NSString*)messageTextForOperation:(PGPmailOperation)operation;
- (NSImage*)imageForOperation:(PGPmailOperation)operation;

- (void)doProgress:(UInt64)bytes total:(UInt64)total;

- (void)dealloc;

@end

#endif /* ] Included_CPGPmailProgress_h */

/*__Editor_settings____

	Local Variables:
	tab-width: 4
	End:
	vi: ts=4 sw=4
	vim: si
_____________________*/