/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.

	$Id: CPGPmailWipeFile.h,v 1.16 2002/10/18 08:37:50 jeffc Exp $
____________________________________________________________________________*/
#ifndef Included_CPGPmailWipeFile_h	/* [ */
#define Included_CPGPmailWipeFile_h

#import <PGP/PGP.h>

#import "CPGPmailController.h"
#import "CPGPmailProgress.h"

#define kConfirmWipeStr			LSPM(@"Are you sure you want to erase the selected items permanently?", @"Permanent Erase")
#define kCannotUndoStr			LSPM(@"You cannot undo this action.", @"Cannot Undo")

#define kProgressScaleFactor 		1024UL

@interface CPGPmailWipeFile : NSObject
{
    CPGPmailController		*mController;
    
    NSFileManager			*mFileManager;
    
    PGPContextRef			mContext;
    PGPPrefRef				mPrefRef;
    
    CPGPmailProgress		*mProgressDialog;
	CPGPmailProgressJob		*mJob;
	NSString				*mWipeFile;
    NSLock					*mLock;
	NSArray					*mFilesToWipe;
        
	PGPUInt32				mNumWipePasses;

    PGPUInt64				mTotalBytesToWipe;
    PGPUInt64				mTotalBytesDone;
    
	PGPWipingPattern		*mPatternList;
	void					*mWipeBuffer;
	PGPUInt32				mWipeBufferSize;
	
    BOOL					mInited;
}

- (id)init;
- (id)initWithController:(CPGPmailController *)controller;
- (void)dealloc;

- (void)setLock:(NSLock*)lock;
- (void)processFiles:(NSArray *)inFiles;

- (PGPContextRef)pgpContext;
- (BOOL)progress:(PGPUInt64)inTotalDone;

- (void)stopRequested;

@end

#endif /* ] Included_CPGPmailWipeFile_h */

/*__Editor_settings____

	Local Variables:
	tab-width: 4
	End:
	vi: ts=4 sw=4
	vim: si
_____________________*/