/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.

	$Id: PGPmailCommon.h,v 1.18 2002/08/26 09:19:15 jeffc Exp $
____________________________________________________________________________*/
#ifndef Included_PGPmailCommon_h	/* [ */
#define Included_PGPmailCommon_h

#include <PGP/PGP.h>

#define kPGPMaxFileNameLength				255

#define kPGPMacFileCreator_PGPkeys			'pgpK'
#define kPGPMacFileCreator_PGPtools			'pgpM'

#define kPGPMacFileType_ArmorFile			'TEXT'
#define kPGPMacFileType_EncryptedData		'pgEF'
#define kPGPMacFileType_SignedData			'pgSF'
#define kPGPMacFileType_DetachedSig			'pgDS'
#define kPGPMacFileType_KeyShares			'pgSK'
#define kPGPMacFileType_Exported509Keys		'pgX5'

#define kPGPMacFileType_Text				kPGPMacFileType_ArmorFile
#define kPGPMacFileType_Unknown				'????'

#ifndef LSPM
#define LSPM(key, comment) \
	    [[NSBundle bundleForClass:[CPGPmailController class]] localizedStringForKey:(key) value:@"" table:(nil)]
#endif

#define kPGPmailSignStr						LSPM(@"Signing", @"Signing")
#define kPGPmailEncryptStr					LSPM(@"Encrypting", @"Encrypting")
#define kPGPmailEncryptSignStr				LSPM(@"Encrypting & Signing", @"Encrypt&Signing")
#define kPGPmailDecryptVerifyStr			LSPM(@"Decrypting/Verifying", @"Decrypting/Verifying")
#define kPGPmailWipeFileStr					LSPM(@"Wiping", @"Wiping")
#define kPGPmailSign1Str					LSPM(@"Sign", @"Sign")
#define kPGPmailEncrypt1Str					LSPM(@"Encrypt", @"Encrypt")
#define kPGPmailEncryptSign1Str				LSPM(@"Encrypt & Sign", @"Encrypt&Sign")
#define kPGPmailDecryptVerify1Str			LSPM(@"Decrypt/Verify", @"Decrypt/Verify")
#define kPGPmailWipeFile1Str				LSPM(@"Wipe", @"Wipe")

#define kPGPmailProcessingStr				LSPM(@"Processing", @"Processing")

#define kStopStr							LSPM(@"Stop", @"Stop")
#define kAlertStr							LSPM(@"Alert", @"Alert")
#define	kCautionStr							LSPM(@"Caution", @"Caution")
#define kWarningStr							LSPM(@"Warning", @"Warning")
#define kErrorStr							LSPM(@"Error", @"Error")
#define kOKStr								LSPM(@"OK", @"OK")
#define kCancelStr							LSPM(@"Cancel", @"Cancel")

#define kFileDisplayServerStore				@".DS_Store"
#define kFileResourceFork					@"/..namedfork/rsrc"
#define kPGPmailDefaultOpenDirectoryKey		@"PGPmailDefaultOpenDirectory"
#define kPGPmailDefaultUseMiniWindow		@"PGPmailDefaultUseMiniWindow"			

#define kNumPGPWipingPatternBytes			512L

typedef enum PGPmailOperation
{
	kPGPmailInvalidOperation	= 0,
	
	kPGPmailEncryptOperation,
	kPGPmailSignOperation,
	kPGPmailEncryptSignOperation,
	kPGPmailDecryptVerifyOperation,
	
	kPGPmailWipeOperation,
	kPGPmailWipeFreeSpaceOperation
} PGPmailOperation;

typedef struct PGPmailSignatureData
{
	PGPEventSignatureData	data;
	char					signingKeyIDStr[ kPGPMaxKeyIDStringSize ];
	PGPBoolean				haveResourceFork;
	PGPBoolean				didNotVerifyResourceFork;
} PGPmailSignatureData;

typedef struct PGPWipingPattern
{
	PGPByte	bytes[kNumPGPWipingPatternBytes];
} PGPWipingPattern;

typedef enum PGPmailForkKind
{
    kPGPmailForkKindData = 0,
    kPGPmailForkKindResource
} PGPmailForkKind;

#define kPGPmailMacBinaryFileLimit		0x7FFFCDB0L	// 2G (0x80000000 - 0x3250 ) = 0x7FFFCDB0
             
#endif /* ] Included_PGPmailCommon_h */


/*__Editor_settings____

	Local Variables:
	tab-width: 4
	End:
	vi: ts=4 sw=4
	vim: si
_____________________*/