/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.

	$Id: PGPmailFileUtilities.h,v 1.8 2002/08/22 22:30:04 jason Exp $
____________________________________________________________________________*/
#ifndef Included_PGPmailFileUtilities_h	/* [ */
#define Included_PGPmailFileUtilities_h

#import <Foundation/Foundation.h>

#define kBinaryFileSuffixStr			LSPM(@".pgp", @".pgp")
#define kGPGBinaryFileSuffixStr			LSPM(@".gpg", @".gpg")
#define kDetachedSigFileSuffixStr		LSPM(@".sig", @".sig")
#define kASCIIFileSuffixStr				LSPM(@".asc", @".asc")
#define kSDAFileSuffixStr				LSPM(@".sda", @".sda")
#define kSEAFileSuffixStr				LSPM(@".sea", @".sea")
#define kKeyShareFileSuffixStr			LSPM(@".shf", @".shf")

#ifdef __cplusplus
    extern "C" {
#endif

typedef struct FileKindInfo
{
	BOOL		isEncrypted;
	BOOL		isSigned;
	BOOL		isDetachedSig;
	BOOL		isKeyShareFile;
	BOOL		isPGPFile;
	BOOL		maybePGPFile;
} FileKindInfo;

	void
GetDefaultEncryptSignName(
    NSString* 		srcName,
    BOOL 			textOutput,
    BOOL			detachedSignature,
    NSString*		*destName );

	BOOL
GetDefaultDecryptVerifyName(
    NSString*		srcName,
    NSString*		*destName );

    BOOL
GetDetachedSigFileSourceName(
    NSString*		sigFileName,
    NSString*		*sourceFileName );

    void
GetUniqueFileName(
    NSString*		inFile,
    NSString*		*outFile);

    void
GetPGPFileKindInfo(
    NSString*		inFile,
    FileKindInfo*	info );

	BOOL
PromptForSignatureSourceFile(
	NSString*		sigFile,
	NSString*		*sourceFile);

    PGPError
MacBinaryConversion(
    PGPFileSpecRef fileRef);

#ifdef __cplusplus
}
#endif

#endif /* ] Included_PGPmailFileUtilities_h */

/*__Editor_settings____

	Local Variables:
	tab-width: 4
	End:
	vi: ts=4 sw=4
	vim: si
_____________________*/