/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation.
    All rights reserved.

    $Id: MessageHeaders.h,v 1.1 2002/08/21 03:17:17 wmalik Exp $
____________________________________________________________________________*/

#import <Foundation/NSObject.h>
#import <Foundation/NSRange.h>
#import <Foundation/NSDate.h>

@class NSDate;
@class Message;
@class NSData;
@class NSArray;

@interface MessageHeaders:NSObject <NSCopying>
{
    Message *_message;
    NSString *_to;
    NSString *_subject;
    NSString *_sender;
    unsigned int _dateSentInterval;
    unsigned int _dateReceivedInterval;
    unsigned char _subjectPrefixLength;
}

+ localizedHeaders;
+ localizedHeadersFromEnglishHeaders:fp12;
+ englishHeadersFromLocalizedHeaders:fp12;
- init;
- initWithHeaders:fp12;
- initWithMessage:fp12;
- _initWithMessage:fp12 sender:fp16 subject:fp20 dateSent:fp24 dateReceived:fp28;
- initWithMessage:fp12 sender:fp16 subject:fp20 dateSent:fp24 dateReceived:fp28;
- initWithMessage:fp12 sender:fp16 to:fp20 subject:fp24 dateSent:fp28 dateReceived:fp32;
- copyWithZone:(struct _NSZone *)fp12;
- mutableCopy;
- (void)dealloc;
- (void)setMessage:fp12;
- _headerData;
- (char)_isStructuredHeaderKey:fp12;
- attributedStringShowingHeaderDetailLevel:(int)fp12;
- (unsigned int)subjectPrefixLength;
- subjectNotIncludingReAndFwdPrefix;
- subject;
- (void)setSubject:fp12;
- sender;
- (void)setSender:fp12;
- to;
- (void)setTo:fp12;
- dateReceived;
- (void)setDateReceived:fp12;
- (double)dateReceivedAsTimeIntervalSince1970;
- (char)needsDateReceived;
- dateSent;
- (double)dateSentAsTimeIntervalSince1970;
- (void)setDateSent:fp12;
- messageID;
- allHeaderKeys;
- (void)_setCapitalizedKey:fp12 forKey:fp16;
- _capitalizedKeyForKey:fp12;
- _headerValueForKey:fp12 fromData:fp16;
- (char)hasHeaderForKey:fp12;
- _headerValueForKey:fp12;
- headersForKey:fp12;
- firstHeaderForKey:fp12;
- (void)flushCachedData;
- _decodeHeaderKeysFromData:fp12;
- isoLatin1CharsetHint;
- (void)_appendAddressList:fp12 toData:fp16;
- encodedHeaders;
- encodedHeadersIncludingFromSpace:(char)fp12;
- (void)appendHeaderData:fp12 andRecipients:fp16;
- _encodedHeadersIncludingFromSpace:(char)fp12;
@end