/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation.
    All rights reserved.

    $Id: NSStringMessage.h,v 1.8 2002/08/21 03:17:17 wmalik Exp $
____________________________________________________________________________*/

#import <Foundation/NSString.h>

@interface NSString(IMAPNameEncoding)
- encodedIMAPMailboxName;
- decodedIMAPMailboxName;
@end

@interface NSString(shell_escape)
- _fixStringForShell;
@end

@interface NSString(MimeEnrichedReader)
+ stringFromMimeEnrichedString:fp12;
@end

@interface NSString(MimeHeaderEncoding)
//+ (const struct ? *)preferredMimeEncodingInfo;
+ (unsigned int)preferredMIMEStringEncoding;
//- (const struct ? *)bestMimeEncodingInfo;
- (unsigned int)bestMIMEStringEncoding;
- encodedHeaderData;
- decodeMimeHeaderValue;
- decodeMimeHeaderValueWithCharsetHint:fp12;
@end

@interface NSString(NSEmailAddressString)
- uncommentedAddress;
- uncommentedAddressRespectingGroups;
- addressComment;
- (void)firstName:(id *)fp12 lastName:(id *)fp16;
- addressList;
- (char)isLegalEmailAddress;
@end

@interface NSString(next_reference)
- _nextReferenceName;
@end

@interface NSString(NSStringUtils)
+ stringWithData:fp12 encoding:(unsigned int)fp16;
+ stringRepresentationForBytes:(long long)fp12;
- (char)boolValue;
- smartCapitalizedString;
- stringByReplacingString:fp12 withString:fp16;
- stringByLocalizingReOrFwdPrefix;
- (unsigned int)subjectPrefixLength;
- fileSystemString;
- stringWithNoExtraSpaces;
@end

@interface NSString(PathUtils)
+ pathWithDirectory:fp12 filename:fp16 extension:fp20;
- uniquePathWithMaximumLength:(int)fp12;
- (char)deletePath;
- (char)makeDirectoryWithMode:(int)fp12;
- (char)makePathWritable:(int *)fp12;
- (char)makePathReadOnly:(int *)fp12;
- (void)setPosixFilePermissions:(int)fp12;
- (char)isSubdirectoryOfPath:fp12;
- stringByReallyAbbreviatingWithTildeInPath;
- betterStringByResolvingSymlinksInPath;
@end

@interface NSString(FormatFlowedSupport)
- attributedStringForFlowedTextDeletingSpaces:(char)fp12;
- attributedStringForPlainText;
@end

@interface NSString(EndTruncatingChanges)
- createStringByEndTruncatingForWidth:(float)fp40 usingFont:fp16;
@end
