/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation.
    All rights reserved.

    $Id: PGPMailBundle.h,v 1.3 2002/09/13 01:55:54 jason Exp $
____________________________________________________________________________*/

#import <MVMailBundle.h>

#import <AppKit/NSNibDeclarations.h>

@class MessageHeaders;
@class NSMenuItem;
@class NSMenu;
@class NSMutableDictionary;
@class Message;

@class PGPMailPreferences;

@interface PGPMailBundle : MVMailBundle
{
    PGPContextRef			mPGPContext;
    PGPtlsContextRef		mTLSContext;
    PGPKeyDBRef				mMainKeyDB;
    PGPMailPreferences		*mPrefs;
    
    IBOutlet NSMenuItem		*mEncryptMenuItem;
    IBOutlet NSMenuItem		*mSignMenuItem;
    IBOutlet NSMenuItem		*mDecryptVerifyMenuItem;
    IBOutlet NSMenu			*PGPMenu;
    
    NSMutableDictionary		*mRealToolbarDelegates;
    NSMutableDictionary		*mAdditionalToolbarItemIdentifiers;
    
    char					mPubKeyringPath[PATH_MAX];
    char					mSecKeyringPath[PATH_MAX];
    
    BOOL					mInited;
    BOOL					mLoadedNib;
	BOOL					mSDKInited;
    BOOL					mPrefsInited;
    BOOL					mCleanupDone;
	PGPError				mDecodeError;
}

+ (PGPMailBundle *)pgpController;
+ (NSString *)pgpVersion;

- (NSMenuItem *)pgpSignMenuItem;
- (NSMenuItem *)pgpEncryptMenuItem;
- (NSMenuItem *)pgpDecryptVerifyMenuItem;

- (id)initWithNib:(NSString *)inNibFile;

- (void)pgpInitSDK;
- (void)pgpInitPrefs;
- (void)pgpCleanUp;

- (PGPMailPreferences *)pgpPrefsManager;
- (PGPContextRef)pgpContext;
- (PGPtlsContextRef)pgpTLSContext;
- (PGPPrefRef)pgpPrefRef;
- (PGPKeyDBRef)pgpMainKeyDB;

- (BOOL)pgpEncryptNewMessagesByDefault;
- (void)pgpSetEncryptNewMessagesByDefault:(BOOL)inFlag;
- (BOOL)pgpSignNewMessagesByDefault;
- (void)pgpSetSignNewMessagesByDefault:(BOOL)inFlag;
- (BOOL)pgpUsePGPMIMEWhenSendingMail;
- (BOOL)pgpAutomaticallyDecryptVerifyMessages;
- (BOOL)pgpUsesEncapsulatedSignature;

- (NSString *)pgpVersion;

- (void)mailTo:(id)sender;

- (IBAction)pgpDecryptVerifyMessage:(id)sender;
- (IBAction)pgpToggleEncryptionForNewMessage:(id)sender;
- (IBAction)pgpToggleSignatureForNewMessage:(id)sender;
@end
