/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation.
    All rights reserved.

    $Id: PGPMailEncodeDecode.h,v 1.3 2002/10/12 10:56:13 jason Exp $
____________________________________________________________________________*/

#import "PGPMailCommon.h"
#import <CoreFoundation/CFString.h>
#import <Foundation/NSRange.h>

@class NSArray;
@class NSData;
@class PGPMailBundle;
@class PGPMailPreferences;

@interface PGPMailEncodeDecode : NSObject
{
    PGPMailBundle		*mController;
    PGPMailPreferences	*mPrefs;

    BOOL				mOperationCanceled;
    BOOL				mInited;
}

+ (id)handler;
+ (NSRange)pgpSignedBlockRangeInData:(NSData *)inData;
+ (NSRange)pgpSignatureBlockRangeInData:(NSData *)inData;
+ (NSRange)pgpEncryptionBlockRangeInData:(NSData *)inData;
+ (NSRange)pgpKeyBlockRangeInData:(NSData *)inData;
+ (NSString *)pgpDefaultHashAlgorithm;
+ (NSArray *)pgpKnownHashAlgorithms;
+ (NSData *)pgpConvertedStringData:(NSData *)inData fromEncoding:(CFStringEncoding)inOrigEncoding toEncoding:(CFStringEncoding *)ioNewEncoding;
+ (void)pgpCancelEncodeOperation;
+ (void)pgpCancelDecodeOperation;

- (id)init;
- (id)initWithController:(PGPMailBundle *)inController;
- (void)dealloc;

- (NSData *)pgpEncodeData:(NSData *)inData options:(PGPMailEncodeOptions *)ioOptions recipients:(NSArray *)inRecipients;
- (NSData *)pgpDecryptVerifyData:(NSData *)inData options:(PGPMailDecodeOptions *)ioOptions;
- (NSData *)pgpVerifyMIMEData:(NSData *)inData signature:(NSData *)inSignature options:(PGPMailDecodeOptions *)ioOptions;
- (NSString *)pgpDefaultHashAlgorithm;
- (NSArray *)pgpKnownHashAlgorithms;
@end
