/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation.
    All rights reserved.

    $Id: PGPMailPreferences.h,v 1.1 2002/08/21 03:17:17 wmalik Exp $
____________________________________________________________________________*/

#import <PGP.h>
#import <PGPclient/pgpClientPrefs.h>
#import <PGPclient/CPGPPrefObj.h>

#import <AppKit/AppKit.h>

@class PGPMailBundle;

@interface PGPMailPreferences : NSObject
{
    PGPMailBundle			*mAppController;
	PGPPrefRef				mPrefRef;

    BOOL					mInited;
	BOOL					mLoaded;
}

- (id)init;
- (id)initWithNib:(NSString*)inNibFile;
- (id)initWithController:(PGPMailBundle *)inController;
- (void)dealloc;
- (PGPPrefRef)pgpPrefRef;
- (void)pgpSetPrefRef:(PGPPrefRef)inPrefRef;
- (PGPBoolean)pgpAlwaysEncryptToDefaultKey;
- (PGPUInt32)pgpCacheType;
- (PGPUInt32)pgpCacheSeconds;
- (PGPBoolean)pgpSharePassphraseCacheAmongModules;
- (PGPBoolean)pgpUsePGPMimeWhenSendingMail;
- (PGPBoolean)pgpEncryptNewMessagesByDefault;
- (PGPBoolean)pgpSignNewMessagesByDefault;
- (PGPBoolean)pgpAutoDecryptVerifyWhenOpeningMessges;
- (PGPBoolean)pgpUsesEncapsulatedSignature;
- (PGPBoolean)pgpWordWrapCleanSignedEnabled;
- (PGPUInt32)pgpWordWrapWidth;
- (PGPUInt32)pgpPreferredAlgorithm;
- (PGPPrefArray*)pgpAllowedAlgorithms;
- (PGPError)pgpOpenPrefs;
- (PGPError)pgpClosePrefs;
@end
