/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation.
    All rights reserved.

    $Id: PGPMailProgress.h,v 1.2 2002/09/07 09:25:31 wprice Exp $
____________________________________________________________________________*/

#import <Foundation/NSObject.h>
#import <AppKit/NSNibDeclarations.h>

@class NSButton;
@class NSImageView;
@class NSProgressIndicator;
@class NSPanel;
@class NSTextField;
@class NSBox;

#define kPGPmailViewerProgressNib	@"PGPMailProgress"

@interface PGPMailProgress : NSObject
{
    IBOutlet NSButton 				*mCancelButton;
    IBOutlet NSImageView 			*mLargeIconView;
    IBOutlet NSProgressIndicator 	*mLargeProgressIndicator;
    IBOutlet NSPanel 				*mLargeProgressPanel;
    IBOutlet NSTextField 			*mLargeProgressStatus;
    id								mDelegate;

    BOOL							mInited;
    BOOL							mLoaded;
}

+ (PGPMailProgress *)sharedInstance;
- (id)init;
- (id)initWithNib:(NSString *)inNibFile;
- (void)dealloc;
- (void)startWithMessage:(NSString *)inMessage delegate:(id)inDelegate;
- (void)stopAll;
- (void)stop;
- (IBAction)cancelProcess:(id)sender;
@end

@interface NSObject(PGPMailProgressDelegeate)
- (void)progressIndicatorDidCancel:(PGPMailProgress *)inController;
@end