/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation.
    All rights reserved.

    $Id: PGPMailProgress.m,v 1.6 2002/09/16 03:58:19 wprice Exp $
____________________________________________________________________________*/

#import <Cocoa/Cocoa.h>
#import <PGP/PGP.h>
#import <PGPclient/pgpClientPrefs.h>

#import "PGPMailCommon.h"
#import "PGPMailProgress.h"
#import "PGPMailBundle.h"

static PGPMailProgress 	*sPGPViewerProgress = nil;

@implementation PGPMailProgress
+ (PGPMailProgress *)sharedInstance
{
    if( nil == sPGPViewerProgress )
        sPGPViewerProgress = [[PGPMailProgress alloc] init];

    return sPGPViewerProgress;
}

- (id)init
{
    if( !mInited )
    {
        [super init];
        mInited = YES;
    }

    if( !mLoaded )
        [self initWithNib:kPGPmailViewerProgressNib];

    return self;
}

- (id)initWithNib:(NSString *)inNibFile
{
    if( inNibFile && [inNibFile length] )
        [NSBundle loadNibNamed:inNibFile owner:self];
	else
		NSLog( kPGPmailBadNibFile, __FILE__, __LINE__);
    
	mLoaded = YES;
    
    return [self init];
}

- (void)dealloc
{
    [[mLargeProgressIndicator window] release];
    [super dealloc];
}

- (void)startWithMessage:(NSString *)inMessage
    delegate:(id)inDelegate
{
    mDelegate = inDelegate;
    [mCancelButton setEnabled:NO];
    [[mLargeProgressIndicator window] center];
    [mLargeProgressStatus setStringValue:inMessage];
    [[mLargeProgressIndicator window] makeKeyAndOrderFront:nil];
	[mLargeProgressIndicator setUsesThreadedAnimation:YES];
    [mLargeProgressIndicator startAnimation:nil];
}

- (void)stopAll
{
    [mLargeProgressIndicator stopAnimation:nil];
    [mLargeProgressPanel orderOut:nil];
}

- (void)stop
{
    [self stopAll];
    mDelegate = nil;
}

- (IBAction)cancelProcess:(id)sender
{
    [self stopAll];
    if( mDelegate )
        [mDelegate progressIndicatorDidCancel:self];
    mDelegate = nil;
}
@end
