/*____________________________________________________________________________
		Copyright (C) 2002 PGP Corporation
        All rights reserved.

        $Id: Cast5.h,v 1.3 2002/08/06 20:10:19 dallen Exp $
____________________________________________________________________________*/

/*****************************************************************************
 *					C A S T 5   S Y M M E T R I C   C I P H E R
 *		Copyright (c) 1996 Northern Telecom Ltd. All rights reserved.
 *****************************************************************************
 *
 * FILE:		cast5.h
 *
 * AUTHOR(S):	R.T.Lockhart, Dept. 9C40, Nortel Ltd.
 *				C. Adams, Dept 9C21, Nortel Ltd.
 *
 * DESCRIPTION: CAST5 header file. This file defines the interface for
 * the CAST5 symmetric-key encryption/decryption/MACing code. The code
 * supports key lengths from 8 through 128 bits, in multiples of 8.
 *
 *
 * Error handling:
 * Most functions return an int that indicates the success or failure of the
 * operation. See the C5E_xxx #defines for a list of error conditions.
 *	
 * Data size assumptions: 	BYTE	- unsigned 8 bits
 *				UINT32	- unsigned 32 bits
 *
 ****************************************************************************/

#ifndef Included_Cast5_h	// [
#define Included_Cast5_h

// Can't use ANY namespace here due to compiler bug with NAKED functions

// Constants

#define	USE_CAST5_ASSEMBLY	1


// Exported Functions

void __cdecl	CAST5Schedule(PGPUInt32 xkey[32], const PGPUInt8 *k);

void __cdecl	CAST5Encrypt(const PGPUInt8 *in, PGPUInt8 *out, 
	const PGPUInt32 *xkey);
void __cdecl	CAST5Decrypt(const PGPUInt8 *in, PGPUInt8 *out, 
	const PGPUInt32 *xkey);

void __cdecl	CAST5EncryptCFBdbl(const PGPUInt32 *xkey, PGPUInt32 iv0, 
	PGPUInt32 iv1, PGPUInt32 iv2, PGPUInt32 iv3, const PGPUInt32 *src, 
	PGPUInt32 *dest, PGPUInt32 len);
void __cdecl	CAST5DecryptCFBdbl(const PGPUInt32 *xkey, PGPUInt32 iv0, 
	PGPUInt32 iv1, PGPUInt32 iv2, PGPUInt32 iv3, const PGPUInt32 *src, 
	PGPUInt32 *dest, PGPUInt32 len);

#endif	// ] Included_Cast5_h
