/*____________________________________________________________________________
		Copyright (C) 2002 PGP Corporation
        All rights reserved.

        $Id: CPGPdiskUI.h,v 1.5 2002/08/06 20:10:20 dallen Exp $
____________________________________________________________________________*/

#ifndef Included_CPGPdiskUI_h	// [
#define Included_CPGPdiskUI_h

#include "CString.h"
#include "pgpDiskUI.h"

_PGP_BEGIN

// Class CPGPdiskUI

class CPGPdiskUI
{
	DECLARE_MODALSTATE(CPGPdiskUI);

public:
	static void	InitLibrary();
	static void	CleanupLibrary();

	static void	AskChooseDisk(PGPdiskContextRef context, 
		CString& chosenPath, const char *defaultPath = NULL, 
		const char *title = NULL, void *parentWnd = NULL);

	static void	AskMountDisk(PGPdiskContextRef context, const char *path, 
		void *parentWnd = NULL);
	static void	AskEditDisk(PGPdiskContextRef context, const char *path, 
		void *parentWnd = NULL);
	static void	AskCreateNewDisk(PGPdiskContextRef context, 
		const char *defaultPath = NULL, void *parentWnd = NULL);
	static void	AskUnmountDisk(PGPdiskContextRef context, 
		const char *pathOrRoot, void *parentWnd = NULL, 
		PGPUInt32 flags = kPGPdiskNoUnmountFlags);
	static void	AskUnmountAllDisks(PGPdiskContextRef context, 
		void *parentWnd = NULL, PGPUInt32 flags = kPGPdiskNoUnmountFlags);
	static void	MountStartupDisks(PGPdiskContextRef context, 
		void *parentWnd = NULL);
};


// Class CPGPdiskUI member functions

inline 
void 
CPGPdiskUI::InitLibrary()
{
	PGPError	error	= PGPdiskUIInitLibrary();
	THROW_IF_PGPERROR(error);
}

inline 
void 
CPGPdiskUI::CleanupLibrary()
{
	PGPdiskUICleanupLibrary();
}

inline 
void 
CPGPdiskUI::AskChooseDisk(
	PGPdiskContextRef	context, 
	CString&			chosenPath, 
	const char			*defaultPath, 
	const char			*title, 
	void				*parentWnd)
{
	PGPError	error	= PGPdiskAskChooseDisk(context, defaultPath, title, 
		parentWnd, chosenPath.GetBuffer(kPGPdiskMaxPathLength), 
		kPGPdiskMaxPathLength);
	chosenPath.ReleaseBuffer();

	THROW_IF_PGPERROR(error);
}

inline 
void 
CPGPdiskUI::AskMountDisk(
	PGPdiskContextRef	context, 
	const char			*path, 
	void				*parentWnd)
{
	PGPError	error	= PGPdiskAskMountDisk(context, path, parentWnd);
	THROW_IF_PGPERROR(error);
}

inline 
void 
CPGPdiskUI::AskEditDisk(
	PGPdiskContextRef	context, 
	const char			*path, 
	void				*parentWnd)
{
	PGPError	error	= PGPdiskAskEditDisk(context, path, parentWnd);
	THROW_IF_PGPERROR(error);
}

inline 
void 
CPGPdiskUI::AskCreateNewDisk(
	PGPdiskContextRef	context, 
	const char			*defaultPath, 
	void				*parentWnd)
{
	PGPError	error	= PGPdiskAskCreateNewDisk(context, defaultPath, 
		parentWnd);
	THROW_IF_PGPERROR(error);
}

inline 
void 
CPGPdiskUI::AskUnmountDisk(
	PGPdiskContextRef	context, 
	const char			*pathOrRoot, 
	void				*parentWnd, 
	PGPUInt32			flags)
{
	PGPError	error	= PGPdiskAskUnmountDisk(context, pathOrRoot, 
		parentWnd, flags);
	THROW_IF_PGPERROR(error);
}

inline 
void 
CPGPdiskUI::AskUnmountAllDisks(
	PGPdiskContextRef	context, 
	void				*parentWnd, 
	PGPUInt32			flags)
{
	PGPError	error	= PGPdiskAskUnmountAllDisks(context, parentWnd, 
		flags);
	THROW_IF_PGPERROR(error);
}

inline 
void 
CPGPdiskUI::MountStartupDisks(PGPdiskContextRef context, void *parentWnd)
{
	PGPError	error	= PGPdiskMountStartupDisks(context, parentWnd);
	THROW_IF_PGPERROR(error);
}

_PGP_END

#endif	// ] Included_CPGPdiskUI_h
