/*____________________________________________________________________________
		Copyright (C) 2002 PGP Corporation
        All rights reserved.

        $Id: UFileSys.h,v 1.2 2002/08/06 20:10:18 dallen Exp $
____________________________________________________________________________*/

#include "FileSys.h"

#ifndef Included_UFileSys_h	// [
#define Included_UFileSys_h

_PGP_BEGIN

namespace UFileSys
{
	// Types
	struct FatData
	{
		FileSys::Type	fdFsType;		// must be a FAT variant

		PGPUInt8	fdActiveFat;		// index of active FAT
		PGPUInt8	fdFatCount;			// number of FATs

		PGPUInt16	fdBlockSize;		// blocksize of the volume
		PGPUInt16	fdReservedSecs;		// number of reserved sectors
		PGPUInt16	fdRootDirEnts;		// entries in root dir (FAT12/16)
		PGPUInt16	fdSpc;				// sectors per cluster

		PGPUInt32	fdFatSize;			// # of sectors per fat
		PGPUInt32	fdFirstSecFat;		// sector # of first fat
		PGPUInt32	fdFirstClustFile;	// clust # where file's data begins
		PGPUInt32	fdFirstSecData;		// first sector of data area on drive
	};

	// Functions
	PGPBoolean	IsFatFileSys(FileSys::Type fsType);
	PGPBoolean	IsFileSysValidForSize(FileSys::Type fsType, 
		PGPUInt64 megsDisk);

	PGPUInt64	CalcMegsDisk(PGPUInt64 blocksDisk, PGPUInt16 blockSize);

	PGPUInt16	CalcFat16Spc(PGPUInt32 blocksDisk, PGPUInt16 blockSize);
	PGPUInt16	CalcFat32Spc(PGPUInt32 blocksDisk, PGPUInt16 blockSize);

	void		CalcFakeFatGeom(PGPUInt32 blockSize, 
		PGPUInt32& tracksPerCyl, PGPUInt64& cylinders, 
		PGPUInt32& secsPerTrack);

	void		CalcFatSize(FatData& fatData, PGPUInt32 blocksDisk);
	void		CalcFatDataSec(FatData& fat);
	void		InitFatData(PGPUInt32 blocksDisk, FileSys::Type fsType, 
		FatData& fatData);
};

_PGP_END

#endif	// Included_UFileSys_h
