/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.

	$Id: CPGPnetFilterDriver.h,v 1.4 2002/08/06 20:10:26 dallen Exp $
____________________________________________________________________________*/

#ifndef Included_CPGPnetFilterDriver_h
#define Included_CPGPnetFilterDriver_h
#include "pgpNetPMCfg.h"

class CPGPnetFilterAdapter;

class CPGPnetFilterDriver : public CPGPnetDriver
{
public:
	NDIS_HANDLE				NdisProtocolHandle;
	NDIS_HANDLE				NdisAdapterHandle;

    NDIS_TIMER				collection_timer;

	PGPUInt32				totalBindings;
	PGPUInt32				protocolBindings;

	NDIS_HANDLE				cfgAdapterHandle;
	PGPnetCfgReceiveT			cfgReceiveHandler;
	PGPnetCfgReceiveCompleteT	cfgReceiveCompleteHandler;

	PGPnetCfgSendCompleteT		cfgSendCompleteHandler;

	PGPUInt32				cfgAdapterIPAddress;

	NDIS_TIMER				statusTimer;

	UINT					PGPnetAdapterInstanceCount;
	CPGPnetFilterAdapter*		PGPnetAdapterInstance[ADAPTER_INSTANCE_MAXIMUM];


#if !defined(CHICAGO) && !defined(NDIS40)
	PGPUInt32 dns1;
	PGPUInt32 dns2;
#endif

	PGPBoolean				unregisterred;

	CPGPnetFilterAdapter	*activeFilterAdapter;

public:
	CPGPnetFilterDriver();
	~CPGPnetFilterDriver();

	CPGPnetFilterAdapter* GetActiveFilterAdapter(PGPUserValue userValue);

	VOID FreePGPnetAdapter(CPGPnetFilterAdapter* adapter);

	VOID PMRegister();
	VOID PMUnRegister();

	virtual NDIS_STATUS OpenAdapterRequest() = 0;
	virtual NDIS_STATUS HookAdapterRequest() = 0;

	static CPGPnetFilterDriver* GetCurrentDriver();

	static VOID FragmentCollection(
					PVOID SystemArg1,
					PVOID Context,
					PVOID SystemArg2,
					PVOID SystemArg3);

	static PGPBoolean PGPCheckIp(PGPUInt32 ipToCheck);
};

#define PGPnetFilterDriver CPGPnetFilterDriver::GetCurrentDriver()

#endif // #define Included_CPGPnetFilterDriver_h