/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.
 
	$Id: pgpKernelTiming.c,v 1.5 2002/08/06 20:10:27 dallen Exp $
____________________________________________________________________________*/
#include "pgpKernelTiming.h"

#if PGP_WIN32
#	ifndef CHICAGO
#	include <ndis.h>
#   else
extern PGPUInt32 PgpKernelGetSystemTime();
#	endif
#endif

#if PGP_MACINTOSH
#include "pgpMilliseconds.h"
#endif

#if PGP_UNIX_LINUX
#include "pgpnet.h"
#include <linux/sched.h>
#endif

PGPUInt32 PGPKernelGetMilliseconds()
{
#if PGP_WIN32

#	ifdef CHICAGO

	return PgpKernelGetSystemTime();

#	else

	LARGE_INTEGER now;

	KeQuerySystemTime(&now);
	return (PGPUInt32) (now.QuadPart / 10000);

#	endif

#elif PGP_MACINTOSH

	return PGPGetMilliseconds();

#elif PGP_UNIX_LINUX

	return jiffies / HZ * 1000;

#elif PGP_UNIX_DARWIN
	struct timeval	tv;

	microtime(&tv);
	
	return (tv.tv_sec * 1000) + (tv.tv_usec / 1000);

#else

#	error PGPKernelGetMilliseconds not implemented for this platform!
	return 0;

#endif
}


/*__Editor_settings____

	Local Variables:
	tab-width: 4
	End:
	vi: ts=4 sw=4
	vim: si
_____________________*/
