/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation
    All rights reserved.

    $Id: PGPController.h,v 1.15 2002/10/24 07:21:03 jeffc Exp $
____________________________________________________________________________*/

#import <PGP/PGP.h>
#import <PGPclient/PGPOpenPrefs.h>

#import "PGPBundle.h"

@class NSView;

@protocol PGPController

- (PGPContextRef)pgpContext;
- (PGPPrefRef)pgpPrefRef;
- (PGPtlsContextRef)tlsContext;
- (PGPKeyDBRef)mainKeyDB;

- (void)setView:(NSView*)view;
- (void)setCurrentBundle:(id <PGPBundle>)controller passive:(BOOL)passive;
- (void)finishedHandlingDocument:(NSString*)file;

- (BOOL)canDisplayMainWindow;
- (NSWindow*)mainWindow;
- (NSArray*)menuItems;
- (NSArray*)launchedDocuments;
- (void)addMenu:(NSMenu*)menu withIdentifier:(NSString*)identifier;
- (void)addMenu:(NSMenu*)menu withIdentifier:(NSString*)identifier atIndex:(unsigned)index;
- (void)addMenuItem:(NSMenuItem*)menuItem withIdentifier:(NSString*)identifier;
- (void)addMenuItem:(NSMenuItem*)menuItem withIdentifier:(NSString*)identifier atIndex:(unsigned)index;

@end
