/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.

	$Id: PGPnetDriverComm.h,v 1.9 2002/08/06 20:10:27 dallen Exp $
____________________________________________________________________________*/

#ifndef Included_PGPnetDriverComm_h
#define Included_PGPnetDriverComm_h

#include "pgpIKE.h"
#include "pgpNetKernelXChng.h"
#include "pgpNetPrefsBlockedEntry.h"
#include "pgpNetPrefsFirewallRule.h"

#ifdef __cplusplus
extern "C" {
#endif


#if PGP_UNIX_DARWIN
#	define	kPGPnetNKEHandle		0x5047506E	/*	'PGPn'	*/
#	define	kPGPnetInterfaceFamily	0x1234
#endif




#define	kPGPnetNewSAMsg					100
#define	kPGPnetRemoveSAMsg				101
#define	kPGPnetFailedSAMsg				102
#define kPGPnetUpdateSAMsg				103
#define	kPGPnetNewHostMsg				104
#define kPGPnetAllHostsMsg				105
#define	kPGPnetShutdownMsg				106
#define	kPGPnetNewConfigMsg				107
#define kPGPnetUpdateSubnetMaskMsg		108
#define	kPGPnetUpdateBlockedHostsMsg	109
#define	kPGPnetUpdateFirewallRulesMsg	110
#define	kPGPnetIdentityMsg				111
#define	kPGPnetStartupMsg				112



typedef struct PGPnetNewSAMsg {
	PGPnetKernelMsgType	type;
	PGPipsecSA			sa;
} PGPnetNewSAMsg;



typedef struct PGPnetRemoveSAMsg {
	PGPnetKernelMsgType	type;
	PGPipsecSPI			spi;
} PGPnetRemoveSAMsg;



typedef struct PGPnetFailedSAMsg {
	PGPnetKernelMsgType	type;
	PGPikeMTSAFailed	saFailed;
} PGPnetFailedSAMsg;



typedef struct PGPnetUpdateSAMsg {
	PGPnetKernelMsgType	type;
	PGPipsecSA			sa;
} PGPnetUpdateSAMsg;



typedef struct PGPnetNewHostMsg {
	PGPnetKernelMsgType	type;
	PGPnetKernelHost	host;
} PGPnetNewHostMsg;



typedef struct PGPnetAllHostsMsg {
	PGPnetKernelMsgType	type;
	PGPSize				numHosts;
	PGPnetKernelHost	hosts[1];
} PGPnetAllHostsMsg;



typedef struct PGPnetShutdownMsg {
	PGPnetKernelMsgType	type;
} PGPnetShutdownMsg;



typedef struct PGPnetNewConfigMsg {
	PGPnetKernelMsgType	type;
	PGPnetKernelConfig	config;
} PGPnetNewConfigMsg;



typedef struct PGPnetUpdateSubnetMaskMsg {
	PGPnetKernelMsgType	type;
	PGPSize				numIPs;
	PGPnetIPinfo		ipInfo[1];
} PGPnetUpdateSubnetMaskMsg;



typedef struct PGPnetUpdateBlockedHostsMsg {
	PGPnetKernelMsgType	type;
	PGPSize				numHosts;
	PGPUInt32			hosts[1];
} PGPnetUpdateBlockedHostsMsg;



typedef struct PGPnetUpdateFirewallRulesMsg {
	PGPnetKernelMsgType		type;
	PGPSize					numRules;
	PGPNetPrefFirewallRule	rules[1];
} PGPnetUpdateFirewallRulesMsg;



typedef struct PGPnetIdentityMsg {
	PGPnetKernelMsgType	type;
	PGPikeMTIdentity	id;
} PGPnetIdentityMsg;



typedef struct PGPnetStartupMsg {
	PGPnetKernelMsgType	type;
	PGPUInt8			status;
} PGPnetStartupMsg;

#define	kPGPnetStartupMsg_ServiceReady		1
#define	kPGPnetStartupMsg_KernelReady		2



typedef union PGPnetDriverMsg {
	PGPnetKernelMsgType				type;
	PGPnetNewSAMsg					newSA;
	PGPnetRemoveSAMsg				removeSA;
	PGPnetFailedSAMsg				failedSA;
	PGPnetUpdateSAMsg				updateSA;
	PGPnetNewHostMsg				newHost;
	PGPnetAllHostsMsg				allHosts;
	PGPnetShutdownMsg				shutdown;
	PGPnetNewConfigMsg				newConfig;
	PGPnetUpdateSubnetMaskMsg		updateSubnetMask;
	PGPnetUpdateBlockedHostsMsg		updateBlockedHosts;
	PGPnetUpdateFirewallRulesMsg	updateFirewallRules;
	PGPnetIdentityMsg				identity;
	PGPnetStartupMsg				startup;
} PGPnetDriverMsg;



#ifdef __cplusplus
}
#endif

#endif