/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.

	$Id: pgpClientLibCocoa.h,v 1.31 2002/09/11 08:13:10 jeffc Exp $
____________________________________________________________________________*/
#ifndef Included_pgpClientLibCocoa_h	/* [ */
#define Included_pgpClientLibCocoa_h

#import <PGP/PGP.h>
#import <PGPclient/pgpClientLib.h>
#import <PGPclient/pgpClientLibOSX.h>

#import "pgpEncodeDecodeData.h"

#import <Cocoa/Cocoa.h>

#ifndef LSCL
#define LSCL(key, comment) \
	    [[NSBundle bundleForClass:[CRemoteAuth class]] localizedStringForKey:(key) value:@"" table:(nil)]
#endif

#define kPGPKeySetPBoardType				@"PGPKeySetPBoardType"

#if PGP_DEBUG
#define PGPLog(x)			NSLog x
#else
#define PGPLog(x)
#endif

#define kPGPkeysPubringOSType					'pgPR'
#define kPGPkeysSecringOSType					'pgRR'
#define kPGPdiskFileOSType						'Dsk1'
#define kPGPShareFileOSType						'pgSK'

#define kPGPPubKeyringFileType					@"PGP Public Keyring File"
#define kPGPSecKeyringFileType					@"PGP Private Keyring File"
#define kPGPDetachedSigFileType					@"PGP Detached Signature File"
#define kPGPEncryptedFileType					@"PGP Encrypted File"
#define kPGPDiskImageFileType					@"PGPdisk Image File"
#define kPGPCertificateFileType					@"PGP Certificate File"
#define kPGPExportedKeyFileType					@"PGP Exported Key File"
#define kPGPKeyShareFileType					@"PGP Key Share File"
#define kPGPRandomSeedFileType					@"PGP Random Seed File"
#define kPGPVPNHostsFileType					@"PGP VPN Hosts File"
#define kPGPFirewallRulesFileType				@"PGP Firewall Rules File"

/* General preferences */
#define kPGPclPrefNotification_PrefsViewActive		@"PGPPref.PrefsViewActive"
#define kPGPclPrefNotification_PrefsViewInactive	@"PGPPref.PrefsViewInactive"
#define kPGPclPrefNotification_UpdateKeyrings		@"PGPPref.UpdateKeyrings"

/* Preferences maintained by PGP.app */
#define kPGPclPrefNotification_EncryptToSelf		@"PGPPref.kPGPPrefEncryptToSelf"
#define kPGPclPrefNotification_DefaultMacBinary		@"PGPPref.kPGPPrefMacBinaryDefault"
#define kPGPclPrefNotification_FastKeyGen			@"PGPPref.kPGPPrefFastKeyGen"
#define kPGPclPrefNotification_Comment				@"PGPPref.kPGPPrefComment"
#define kPGPclPrefNotification_CacheType			@"PGPPref.kPGPPrefCacheType"
#define kPGPclPrefNotification_CacheSeconds			@"PGPPref.kPGPPrefCacheSeconds"
#define kPGPclPrefNotification_ShareCache			@"PGPPref.kPGPPrefShareCache"
#define kPGPclPrefNotification_WarnOnWipe			@"PGPPref.kPGPPrefWarnOnWipe"
#define kPGPclPrefNotification_FileWipePasses		@"PGPPref.kPGPPrefFileWipePasses"
#define kPGPclPrefNotification_PreferredAlg			@"PGPPref.kPGPPrefPreferredAlgorithm"
#define kPGPclPrefNotification_AllowedAlgs			@"PGPPref.kPGPPrefAllowedAlgorithmsList"
#define kPGPclPrefNotification_DisplayValidity		@"PGPPref.kPGPPrefDisplayMarginalValidity"
#define kPGPclPrefNotification_InvalidateMVKeys		@"PGPPref.kPGPPrefMarginalIsInvalid"
#define kPGPclPrefNotification_WarnOnADK			@"PGPPref.kPGPPrefWarnOnADK"
#define kPGPclPrefNotification_ExportCompatible		@"PGPPref.kPGPPrefExportKeysCompatible"
#define kPGPclPrefNotification_LicenseNumber		@"PGPPref.kPGPPrefLicenseNumber"
#define kPGPclPrefNotification_LicenseAuthorization	@"PGPPref.kPGPPrefLicenseAuthorization"
#define kPGPclPrefNotification_LicenseName			@"PGPPref.kPGPPrefLicenseName"
#define kPGPclPrefNotification_LicenseCompany		@"PGPPref.kPGPPrefLicenseCompany"

/* Preferences maintained by PGPdisk.bundle */
#define kPGPclPrefNotification_ForcibleUnmounts		@"PGPPref.kPGPPrefDiskAllowForcibleUnmounts"
#define kPGPclPrefNotification_AutoUnmount			@"PGPPref.kPGPPrefDiskUnmountOnInactivity"
#define kPGPclPrefNotification_UnmountTimeout		@"PGPPref.kPGPPrefDiskAutoUnmountTimeout"
#define kPGPclPrefNotification_UnmountLogout		@"PGPPref.kPGPPrefDiskAutoUnmountOnLogout"
#define kPGPclPrefNotification_UnmountSleep			@"PGPPref.kPGPPrefDiskAutoUnmountOnSleep"
#define kPGPclPrefNotification_PreventSleep			@"PGPPref.kPGPPrefDiskNoSleepIfFailAU"

/* Preferences maintained by PGPkeys.bundle */
#define kPGPclPrefNotification_PubKeyring			@"PGPPref.kPGPPrefPublicKeyringFile"
#define kPGPclPrefNotification_SecKeyring			@"PGPPref.kPGPPrefPrivateKeyringFile"
#define kPGPclPrefNotification_KeyServerList		@"PGPPref.kPGPPrefKeyServerList"
#define kPGPclPrefNotification_SyncUnknownKeys		@"PGPPref.kPGPPrefKeyServerSyncUnknownKeys"
#define kPGPclPrefNotification_SyncOnKeySign		@"PGPPref.kPGPPrefKeyServerSyncOnKeySign"
#define kPGPclPrefNotification_SyncOnAdd			@"PGPPref.kPGPPrefKeyServerSyncOnAdd"
#define kPGPclPrefNotification_SyncOnRevoke			@"PGPPref.kPGPPrefKeyServerSyncOnRevocation"
#define kPGPclPrefNotification_SyncOnVerify			@"PGPPref.kPGPPrefKeyServerSyncOnVerify"
#define kPGPclPrefNotification_ServerURL			@"PGPPref.kPGPPrefCAServerURL"
#define kPGPclPrefNotification_RevocationServerURL	@"PGPPref.kPGPPrefCARevocationServerURL"
#define kPGPclPrefNotification_CAType				@"PGPPref.kPGPPrefCAType"
#define kPGPclPrefNotification_RootCertificate		@"PGPPref.kPGPPrefCARootKeyID"

/* Preferences maintained by PGPmail.bundle */
#define kPGPclPrefNotification_UsePGPMIME			@"PGPPref.kPGPPrefMailSignPGPMIME"
#define kPGPclPrefNotification_EncryptByDefault		@"PGPPref.kPGPPrefMailEncryptDefault"
#define kPGPclPrefNotification_SignByDefault		@"PGPPref.kPGPPrefMailSignDefault"
#define kPGPclPrefNotification_AutoDecrypt			@"PGPPref.kPGPPrefAutoDecrypt"
#define kPGPclPrefNotification_WordWrapEnabled		@"PGPPref.kPGPPrefWordWrapEnable"
#define kPGPclPrefNotification_WordWrapWidth		@"PGPPref.kPGPPrefWordWrapWidth"

/* Preferences maintained by PGPnet.bundle */
#define kPGPclPrefNotification_EnableVPN			@"PGPnetPref.kPGPNetPrefEnableVPN"
#define kPGPclPrefNotification_DynamicVPN			@"PGPnetPref.kPGPnetPrefUnconfiguredMode"
#define kPGPclPrefNotification_IKETimeExpires		@"PGPnetPref.kPGPNetPrefEnableIKETimeExpiration"
#define kPGPclPrefNotification_IPSECTimeExpires		@"PGPnetPref.kPGPNetPrefEnableIPSECTimeExpiration"
#define kPGPclPrefNotification_IPSECKByteExpires	@"PGPnetPref.kPGPNetPrefEnableIPSECKByteExpiration"
#define kPGPclPrefNotification_IKETimeExpiration	@"PGPnetPref.kPGPNetPrefIKETimeExpiration"
#define kPGPclPrefNotification_IPSECTimeExpiration	@"PGPnetPref.kPGPNetPrefIPSECTimeExpiration"
#define kPGPclPrefNotification_IPSECKByteExpiration	@"PGPnetPref.kPGPNetPrefIPSECKByteExpiration"
#define kPGPclPrefNotification_ReqValidKeyConfig	@"PGPnetPref.kPGPNetPrefRequireValidKeyConfigured"
#define kPGPclPrefNotification_ReqValidKeyUnconfig	@"PGPnetPref.kPGPNetPrefRequireValidKeyUnconfigured"
#define kPGPclPrefNotification_PGPAuthKeyID			@"PGPnetPref.kPGPNetPrefPGPAuthKeyID"
#define kPGPclPrefNotification_X509AuthCert			@"PGPnetPref.kPGPNetPrefX509AuthKeyID"
#define kPGPclPrefNotification_AllowCAST			@"PGPnetPref.kPGPNetPrefAllowCipherCAST"
#define kPGPclPrefNotification_AllowTripleDES		@"PGPnetPref.kPGPNetPrefAllowCipher3DES"
#define kPGPclPrefNotification_AllowCipherNone		@"PGPnetPref.kPGPNetPrefAllowCipherNone"
#define kPGPclPrefNotification_AllowSHA1			@"PGPnetPref.kPGPNetPrefAllowHashSHA1"
#define kPGPclPrefNotification_AllowMD5				@"PGPnetPref.kPGPNetPrefAllowHashMD5"
#define kPGPclPrefNotification_AllowHashNone		@"PGPnetPref.kPGPNetPrefAllowHashNone"
#define kPGPclPrefNotification_AllowDH1024			@"PGPnetPref.kPGPNetPrefAllowDH1024"
#define kPGPclPrefNotification_AllowDH1536			@"PGPnetPref.kPGPNetPrefAllowDH1536"
#define kPGPclPrefNotification_AllowDHEC163			@"PGPnetPref.kPGPNetPrefAllowEC163"
#define kPGPclPrefNotification_AllowDHEC283			@"PGPnetPref.kPGPNetPrefAllowEC283"
#define kPGPclPrefNotification_AllowLZS				@"PGPnetPref.kPGPNetPrefAllowCompLZS"
#define kPGPclPrefNotification_AllowDeflate			@"PGPnetPref.kPGPNetPrefAllowCompDeflate"
#define kPGPclPrefNotification_IKEProposals			@"PGPnetPref.kPGPNetPrefIKEProposalArray"
#define kPGPclPrefNotification_IPsecProposals		@"PGPnetPref.kPGPNetPrefIPSecProposalArray"
#define kPGPclPrefNotification_IPsecGroupID			@"PGPnetPref.kPGPnetPrefIPSECGroupID"
#define kPGPclPrefNotification_EnableIDS			@"PGPnetPref.kPGPNetPrefUseIntrusionDetection"
#define kPGPclPrefNotification_AutoBlockAttackers	@"PGPnetPref.kPGPNetPrefAutoBlockAttacks"
#define kPGPclPrefNotification_BlockUntilRemoved	@"PGPnetPref.kPGPNetPrefBlockUntilRemoved"
#define kPGPclPrefNotification_BlockMinutes			@"PGPnetPref.kPGPnetPrefBlockMinutes"
#define kPGPclPrefNotification_DisplayAttackDialog	@"PGPnetPref.kPGPNetPrefAttackDialog"
#define kPGPclPrefNotification_PlayAttackSound		@"PGPnetPref.kPGPNetPrefAttackSound"
#define kPGPclPrefNotification_EmailAttacks			@"PGPnetPref.kPGPNetPrefAttackEmailNotify"
#define kPGPclPrefNotification_AttackRecipient		@"PGPnetPref.kPGPNetPrefAttackNotifyEmail"
#define kPGPclPrefNotification_OutgoingSMTPServer	@"PGPnetPref.kPGPNetPrefAttackNotifySMTPServer"

extern NSString *	kPGPPrefsDomain;

enum
{
	kPGPclKeySelect_SingleKey		= (1L << 0),
	kPGPclKeySelect_FreeKeySet		= (1L << 1),
	kPGPclKeySelect_ImportVariation	= (1L << 2),

	kPGPclKeySelect_Default = 0
};

enum
{
	kPGPclCertSelect_CanSignOnly	= (1L << 0),
	kPGPclCertSelect_NoSplit		= (1L << 1),

	kPGPclCertSelect_Default = 0
};

typedef struct PGPKeySetPBoardStruct
{
	PGPContextRef	context;
	PGPKeySetRef	keySet;
} PGPKeySetPBoardStruct;

PGP_BEGIN_C_DECLARATIONS

// PGPclBeginKeySelectSheet didEndSelector should have the following signature:
// - (void)keySelectDidEnd:(PGPError)resultCode selectedKeys:(PGPKeySetRef)keySet

	void
PGPclBeginKeySelectSheet(
	NSString					*prompt,
	NSWindow					*docWindow,
	PGPPrefRef					prefRef,
	PGPKeySetRef				selectFromSet,
	PGPKeyDBRef					mainDB,
	PGPUInt32					flags,
	id							owner,
	SEL							didEndSelector );

// PGPclBeginCertSelectSheet didEndSelector should have the following signature:
// - (void)certSelectDidEnd:(PGPError)resultCode selectedCert:(PGPKeyDBObjRef)cert

	void
PGPclBeginCertSelectSheet(
	NSString					*prompt,
	NSWindow					*docWindow,
	PGPKeyDBRef					fromDB,
	PGPUInt32					flags,
	id							target,
	SEL							didEndSelector );

	NSString *
PGPclGetPrimaryUserIDName(
	PGPKeyDBObjRef				key );

	NSString *
PGPclGetUserIDName(
	PGPKeyDBObjRef				userID );

    NSString *
PGPGetErrorNSString( PGPError theError );

PGP_END_C_DECLARATIONS


#endif /* ] Included_pgpClientLibCocoa_h */


/*__Editor_settings____

	Local Variables:
	tab-width: 4
	End:
	vi: ts=4 sw=4
	vim: si
_____________________*/
