/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.
	
	$Id: pgpRndSeed.mm,v 1.2 2002/08/06 20:10:55 dallen Exp $
____________________________________________________________________________*/

#include <PGP/PGP.h>

#include "pgpFileSpec.h"
#include "pgpMacUtils.h"
#include "pgpRndSeed.h"



#define kPGPSupportFolder			NSLocalizedString(@"PGP", @"Default location for support files")
#define kPGPMacOSXRandomSeedFile	NSLocalizedString(@"PGP Random Seed.rnd", @"MacOSX Random Seed File name")



	PGPError
GetDefaultRandSeedFileRef(
	PGPMemoryMgrRef		mgr,
	PFLFileSpecRef	*	outRef)
{
	PGPError			result;
	OSStatus			err;
	FSRef				ref;
	char				path[256];
	
	err = FSFindFolder(kLocalDomain, kApplicationSupportFolderType, kCreateFolder, &ref);
	if (! err) {
		err = FSRefMakePath(&ref, reinterpret_cast<UInt8 *>(path), 256);
	}
	if (! err) {
		NSAutoreleasePool *	pool = [[NSAutoreleasePool alloc] init];
		NSString *			randSeedPath = [[NSString stringWithCString:path] stringByAppendingPathComponent:kPGPSupportFolder];
		
		[[NSFileManager defaultManager] createDirectoryAtPath:randSeedPath attributes:NULL];
		result = PFLNewFileSpecFromFullPath(mgr, [[randSeedPath stringByAppendingPathComponent:kPGPMacOSXRandomSeedFile] cString],
					outRef);
		[pool release];
	} else {
		result = pgpErrorFromMacError(err, kPGPError_FileNotFound);
	}
	
	return result;
}
		