/*____________________________________________________________________________
    Copyright (C) 2002 PGP Corporation
    All rights reserved.

    $Id: CPGPIcons.m,v 1.3 2002/10/29 08:41:16 wprice Exp $
____________________________________________________________________________*/

#import <PGP/PGP.h>
#import "CPGPIcons.h"

static CPGPIcons *sPGPIconsShared = nil;

@implementation CPGPIcons

+ (id)shared
{
	if( !sPGPIconsShared )
		sPGPIconsShared = [[CPGPIcons alloc] init];
	return sPGPIconsShared;
}

- (id)init
{
	if( !mImages )
	{
		NSBundle *bundle = [NSBundle bundleForClass:[CPGPIcons class]];
		
		mImages = [[NSMutableArray alloc] init];
		
		[mImages addObject:[[[NSImage alloc]
			initByReferencingFile:[bundle pathForImageResource:@"cert"]] autorelease]];
		[mImages addObject:[[[NSImage alloc]
			initByReferencingFile:[bundle pathForImageResource:@"certexpired"]] autorelease]];
		[mImages addObject:[[[NSImage alloc]
			initByReferencingFile:[bundle pathForImageResource:@"certrevoked"]] autorelease]];
		[mImages addObject:[[[NSImage alloc]
			initByReferencingFile:[bundle pathForImageResource:@"dotaxiom"]] autorelease]];
		[mImages addObject:[[[NSImage alloc]
			initByReferencingFile:[bundle pathForImageResource:@"dotdimmed"]] autorelease]];
		[mImages addObject:[[[NSImage alloc]
			initByReferencingFile:[bundle pathForImageResource:@"dotgreen"]] autorelease]];
		[mImages addObject:[[[NSImage alloc]
			initByReferencingFile:[bundle pathForImageResource:@"dotred"]] autorelease]];
		[mImages addObject:[[[NSImage alloc]
			initByReferencingFile:[bundle pathForImageResource:@"dotselect"]] autorelease]];
		[mImages addObject:[[[NSImage alloc]
			initByReferencingFile:[bundle pathForImageResource:@"dsadisabled"]] autorelease]];
		[mImages addObject:[[[NSImage alloc]
			initByReferencingFile:[bundle pathForImageResource:@"dsaexpired"]] autorelease]];
		[mImages addObject:[[[NSImage alloc]
			initByReferencingFile:[bundle pathForImageResource:@"dsakey"]] autorelease]];
		[mImages addObject:[[[NSImage alloc]
			initByReferencingFile:[bundle pathForImageResource:@"dsakeypair"]] autorelease]];
		[mImages addObject:[[[NSImage alloc]
			initByReferencingFile:[bundle pathForImageResource:@"dsarevoked"]] autorelease]];
		[mImages addObject:[[[NSImage alloc]
			initByReferencingFile:[bundle pathForImageResource:@"dsasplit"]] autorelease]];
		[mImages addObject:[[[NSImage alloc]
			initByReferencingFile:[bundle pathForImageResource:@"dsauser"]] autorelease]];
		[mImages addObject:[[[NSImage alloc]
			initByReferencingFile:[bundle pathForImageResource:@"photoid"]] autorelease]];
		[mImages addObject:[[[NSImage alloc]
			initByReferencingFile:[bundle pathForImageResource:@"rsa4disabled"]] autorelease]];
		[mImages addObject:[[[NSImage alloc]
			initByReferencingFile:[bundle pathForImageResource:@"rsa4expired"]] autorelease]];
		[mImages addObject:[[[NSImage alloc]
			initByReferencingFile:[bundle pathForImageResource:@"rsa4key"]] autorelease]];
		[mImages addObject:[[[NSImage alloc]
			initByReferencingFile:[bundle pathForImageResource:@"rsa4keypair"]] autorelease]];
		[mImages addObject:[[[NSImage alloc]
			initByReferencingFile:[bundle pathForImageResource:@"rsa4revoked"]] autorelease]];
		[mImages addObject:[[[NSImage alloc]
			initByReferencingFile:[bundle pathForImageResource:@"rsa4split"]] autorelease]];
		[mImages addObject:[[[NSImage alloc]
			initByReferencingFile:[bundle pathForImageResource:@"rsadisabled"]] autorelease]];
		[mImages addObject:[[[NSImage alloc]
			initByReferencingFile:[bundle pathForImageResource:@"rsaexpired"]] autorelease]];
		[mImages addObject:[[[NSImage alloc]
			initByReferencingFile:[bundle pathForImageResource:@"rsakey"]] autorelease]];
		[mImages addObject:[[[NSImage alloc]
			initByReferencingFile:[bundle pathForImageResource:@"rsakeypair"]] autorelease]];
		[mImages addObject:[[[NSImage alloc]
			initByReferencingFile:[bundle pathForImageResource:@"rsarevoked"]] autorelease]];
		[mImages addObject:[[[NSImage alloc]
			initByReferencingFile:[bundle pathForImageResource:@"rsasplit"]] autorelease]];
		[mImages addObject:[[[NSImage alloc]
			initByReferencingFile:[bundle pathForImageResource:@"rsauser"]] autorelease]];
		[mImages addObject:[[[NSImage alloc]
			initByReferencingFile:[bundle pathForImageResource:@"sig"]] autorelease]];
		[mImages addObject:[[[NSImage alloc]
			initByReferencingFile:[bundle pathForImageResource:@"sigbad"]] autorelease]];
		[mImages addObject:[[[NSImage alloc]
			initByReferencingFile:[bundle pathForImageResource:@"sigexpired"]] autorelease]];
		[mImages addObject:[[[NSImage alloc]
			initByReferencingFile:[bundle pathForImageResource:@"sigexport"]] autorelease]];
		[mImages addObject:[[[NSImage alloc]
			initByReferencingFile:[bundle pathForImageResource:@"sigmeta"]] autorelease]];
		[mImages addObject:[[[NSImage alloc]
			initByReferencingFile:[bundle pathForImageResource:@"sigrevoked"]] autorelease]];
		[mImages addObject:[[[NSImage alloc]
			initByReferencingFile:[bundle pathForImageResource:@"sigti"]] autorelease]];
		[mImages addObject:[[[NSImage alloc]
			initByReferencingFile:[bundle pathForImageResource:@"unknown"]] autorelease]];
		[mImages addObject:[[[NSImage alloc]
			initByReferencingFile:[bundle pathForImageResource:@"unknownuserid"]] autorelease]];
		[mImages addObject:[[[NSImage alloc]
			initByReferencingFile:[bundle pathForImageResource:@"group"]] autorelease]];
		[mImages addObject:[[[NSImage alloc]
			initByReferencingFile:[bundle pathForImageResource:@"ecdisabled"]] autorelease]];
		[mImages addObject:[[[NSImage alloc]
			initByReferencingFile:[bundle pathForImageResource:@"ecexpired"]] autorelease]];
		[mImages addObject:[[[NSImage alloc]
			initByReferencingFile:[bundle pathForImageResource:@"eckey"]] autorelease]];
		[mImages addObject:[[[NSImage alloc]
			initByReferencingFile:[bundle pathForImageResource:@"eckeypair"]] autorelease]];
		[mImages addObject:[[[NSImage alloc]
			initByReferencingFile:[bundle pathForImageResource:@"ecrevoked"]] autorelease]];
		[mImages addObject:[[[NSImage alloc]
			initByReferencingFile:[bundle pathForImageResource:@"ecsplit"]] autorelease]];
		[mImages addObject:[[[NSImage alloc]
			initByReferencingFile:[bundle pathForImageResource:@"ecuser"]] autorelease]];
	}
    return self;
}

- (id)images
{
	return mImages;
}

- (NSImage *)getKeyDBObjIcon:(PGPKeyDBObjRef) keyDBItem
{
	PGPInt32		objType;
	NSImage			*dbImage = NULL;
	PGPInt32		iconID = -1;
	PGPInt32		algorithm;
	PGPBoolean		expired,
					revoked,
					disabled,
					secret,
					split;
	PGPInt32		version;
	
	PGPGetKeyDBObjNumericProperty( keyDBItem, kPGPKeyDBObjProperty_ObjectType, &objType );
	switch( objType )
	{
		case kPGPKeyDBObjType_Key:
			PGPGetKeyDBObjBooleanProperty( keyDBItem, kPGPKeyProperty_IsExpired, &expired );
			PGPGetKeyDBObjBooleanProperty( keyDBItem, kPGPKeyProperty_IsRevoked, &revoked );
			PGPGetKeyDBObjBooleanProperty( keyDBItem, kPGPKeyProperty_IsDisabled, &disabled );
			PGPGetKeyDBObjBooleanProperty( keyDBItem, kPGPKeyProperty_IsSecret, &secret );
			PGPGetKeyDBObjNumericProperty( keyDBItem, kPGPKeyProperty_AlgorithmID, &algorithm );
			PGPGetKeyDBObjNumericProperty( keyDBItem, kPGPKeyProperty_Version, &version );
			if( revoked )
			{
				switch( algorithm )
				{
					case kPGPPublicKeyAlgorithm_DSA:
					case kPGPPublicKeyAlgorithm_ElGamal:
						iconID = kPGPclImage_DSARevoked;
						break;
					default:
					case kPGPPublicKeyAlgorithm_RSA:
					case kPGPPublicKeyAlgorithm_RSASignOnly:
					case kPGPPublicKeyAlgorithm_RSAEncryptOnly:
						if( version == kPGPKeyVersion_V4 )
							iconID = kPGPclImage_RSA4Revoked;
						else
							iconID = kPGPclImage_RSARevoked;
						break;
					case kPGPPublicKeyAlgorithm_ECEncrypt:
					case kPGPPublicKeyAlgorithm_ECSign:
						iconID = kPGPclImage_ECRevoked;
						break;
				}
			}
			else if( expired )
			{
				switch( algorithm )
				{
					case kPGPPublicKeyAlgorithm_DSA:
					case kPGPPublicKeyAlgorithm_ElGamal:
						iconID = kPGPclImage_DSAExpired;
						break;
					default:
					case kPGPPublicKeyAlgorithm_RSA:
					case kPGPPublicKeyAlgorithm_RSASignOnly:
					case kPGPPublicKeyAlgorithm_RSAEncryptOnly:
						if( version == kPGPKeyVersion_V4 )
							iconID = kPGPclImage_RSA4Expired;
						else
							iconID = kPGPclImage_RSAExpired;
						break;
					case kPGPPublicKeyAlgorithm_ECEncrypt:
					case kPGPPublicKeyAlgorithm_ECSign:
						iconID = kPGPclImage_ECExpired;
						break;
				}
			}
			else if( disabled )
			{
				switch( algorithm )
				{
					case kPGPPublicKeyAlgorithm_DSA:
					case kPGPPublicKeyAlgorithm_ElGamal:
						iconID = kPGPclImage_DSADisabled;
						break;
					default:
					case kPGPPublicKeyAlgorithm_RSA:
					case kPGPPublicKeyAlgorithm_RSASignOnly:
					case kPGPPublicKeyAlgorithm_RSAEncryptOnly:
						if( version == kPGPKeyVersion_V4 )
							iconID = kPGPclImage_RSA4Disabled;
						else
							iconID = kPGPclImage_RSADisabled;
						break;
					case kPGPPublicKeyAlgorithm_ECEncrypt:
					case kPGPPublicKeyAlgorithm_ECSign:
						iconID = kPGPclImage_ECDisabled;
						break;
				}
			}
			else if( secret )
			{
				PGPGetKeyDBObjBooleanProperty( keyDBItem, kPGPKeyProperty_IsSecretShared, &split);
				if( split )
				{
					switch( algorithm )
					{
						case kPGPPublicKeyAlgorithm_DSA:
						case kPGPPublicKeyAlgorithm_ElGamal:
							iconID = kPGPclImage_DSASplit;
							break;
						default:
						case kPGPPublicKeyAlgorithm_RSA:
						case kPGPPublicKeyAlgorithm_RSASignOnly:
						case kPGPPublicKeyAlgorithm_RSAEncryptOnly:
							if( version == kPGPKeyVersion_V4 )
								iconID = kPGPclImage_RSA4Split;
							else
								iconID = kPGPclImage_RSASplit;
							break;
						case kPGPPublicKeyAlgorithm_ECEncrypt:
						case kPGPPublicKeyAlgorithm_ECSign:
							iconID = kPGPclImage_ECSplit;
							break;
					}
				}
				else
				{
					switch( algorithm )
					{
						case kPGPPublicKeyAlgorithm_DSA:
						case kPGPPublicKeyAlgorithm_ElGamal:
							iconID = kPGPclImage_DSAKeyPair;
							break;
						default:
						case kPGPPublicKeyAlgorithm_RSA:
						case kPGPPublicKeyAlgorithm_RSASignOnly:
						case kPGPPublicKeyAlgorithm_RSAEncryptOnly:
							if( version == kPGPKeyVersion_V4 )
								iconID = kPGPclImage_RSA4KeyPair;
							else
								iconID = kPGPclImage_RSAKeyPair;
							break;
						case kPGPPublicKeyAlgorithm_ECEncrypt:
						case kPGPPublicKeyAlgorithm_ECSign:
							iconID = kPGPclImage_ECKeyPair;
							break;
					}
				}
			}
			else switch( algorithm )
			{
				case kPGPPublicKeyAlgorithm_DSA:
				case kPGPPublicKeyAlgorithm_ElGamal:
					iconID = kPGPclImage_DSAKey;
					break;
				default:
				case kPGPPublicKeyAlgorithm_RSA:
				case kPGPPublicKeyAlgorithm_RSASignOnly:
				case kPGPPublicKeyAlgorithm_RSAEncryptOnly:
					if( version == kPGPKeyVersion_V4 )
						iconID = kPGPclImage_RSA4Key;
					else
						iconID = kPGPclImage_RSAKey;
					break;
				case kPGPPublicKeyAlgorithm_ECEncrypt:
				case kPGPPublicKeyAlgorithm_ECSign:
					iconID = kPGPclImage_ECKey;
					break;
			}
			
			break;
		case kPGPKeyDBObjType_UserID:
		{
			PGPBoolean	isAttributeID;
			
			PGPGetKeyDBObjBooleanProperty( keyDBItem, kPGPUserIDProperty_IsAttribute, &isAttributeID );
			if( isAttributeID )
			{
				PGPInt32	attributeType;
				
				PGPGetKeyDBObjNumericProperty( keyDBItem, kPGPUserIDProperty_AttributeType, &attributeType );
				if( attributeType == kPGPAttribute_Image )
					iconID		= kPGPclImage_PhotoID;
				else
					iconID		= kPGPclImage_Unknown;
			}
			else
			{
				PGPGetKeyDBObjNumericProperty( PGPPeekKeyDBObjKey( keyDBItem), kPGPKeyProperty_AlgorithmID, &algorithm);
				switch( algorithm )
				{
					case kPGPPublicKeyAlgorithm_DSA:
					case kPGPPublicKeyAlgorithm_ElGamal:
						iconID = kPGPclImage_DSAUser;
						break;
					default:
					case kPGPPublicKeyAlgorithm_RSA:
					case kPGPPublicKeyAlgorithm_RSASignOnly:
					case kPGPPublicKeyAlgorithm_RSAEncryptOnly:
						iconID = kPGPclImage_RSAUser;
						break;
					case kPGPPublicKeyAlgorithm_ECEncrypt:
					case kPGPPublicKeyAlgorithm_ECSign:
						iconID = kPGPclImage_ECUser;
						break;
				}
			}
			break;
		}
		case kPGPKeyDBObjType_Signature:
		{
			PGPBoolean		verified,
							tried,
							notCorrupt,
							exportable,
							x509;
			PGPInt32		trustLevel;
			
			PGPGetKeyDBObjBooleanProperty( keyDBItem, kPGPSigProperty_IsRevoked, &revoked);
			PGPGetKeyDBObjBooleanProperty( keyDBItem, kPGPSigProperty_IsVerified, &verified);
			PGPGetKeyDBObjBooleanProperty( keyDBItem, kPGPSigProperty_IsTried, &tried);
			PGPGetKeyDBObjBooleanProperty( keyDBItem, kPGPSigProperty_IsNotCorrupt, &notCorrupt);
			PGPGetKeyDBObjBooleanProperty( keyDBItem, kPGPSigProperty_IsExportable, &exportable);
			PGPGetKeyDBObjBooleanProperty( keyDBItem, kPGPSigProperty_IsExpired, &expired);
			PGPGetKeyDBObjBooleanProperty( keyDBItem, kPGPSigProperty_IsX509, &x509);
			PGPGetKeyDBObjNumericProperty( keyDBItem, kPGPSigProperty_TrustLevel, &trustLevel);
			if( x509 )
			{
				if( revoked )
					iconID = kPGPclImage_CertRevoked;
				else if( expired )
					iconID = kPGPclImage_CertExpired;
				else
					iconID = kPGPclImage_Cert;
			}
			else if(revoked)
				iconID = 	kPGPclImage_SigRevoked;
			else if(expired)
				iconID =	kPGPclImage_SigExpired;
			else if(verified)
			{
				if(exportable)
				{
					if(trustLevel >= 1)
						iconID =	kPGPclImage_SigTI;
					else
						iconID =	kPGPclImage_SigExport;
				}
				else
				{
					if(trustLevel >= 2)
						iconID =	kPGPclImage_SigMeta;
					else
						iconID =	kPGPclImage_Sig;
				}
			}
			else if(tried)
				iconID =	kPGPclImage_SigBad;
			else if(notCorrupt)
			{
				if( exportable )
					iconID =	kPGPclImage_SigExport;
				else
					iconID =	kPGPclImage_Sig;
			}
			else
				iconID =	kPGPclImage_SigBad;
			break;
		}
		case kPGPKeyDBObjType_SubKey:
			PGPGetKeyDBObjNumericProperty( keyDBItem, kPGPSubKeyProperty_AlgorithmID, &algorithm );
			PGPGetKeyDBObjBooleanProperty( keyDBItem, kPGPSubKeyProperty_IsRevoked, &revoked);
			PGPGetKeyDBObjBooleanProperty( keyDBItem, kPGPSubKeyProperty_IsExpired, &expired);
			switch( algorithm )
			{
				case kPGPPublicKeyAlgorithm_DSA:
				case kPGPPublicKeyAlgorithm_ElGamal:
					if( revoked )
						iconID = kPGPclImage_DSARevoked;
					else if( expired )
						iconID = kPGPclImage_DSAExpired;
					else
						iconID = kPGPclImage_DSAKey;
					break;
				default:
				case kPGPPublicKeyAlgorithm_RSA:
				case kPGPPublicKeyAlgorithm_RSASignOnly:
				case kPGPPublicKeyAlgorithm_RSAEncryptOnly:
					if( revoked )
						iconID = kPGPclImage_RSA4Revoked;
					else if( expired )
						iconID = kPGPclImage_RSA4Expired;
					else
						iconID = kPGPclImage_RSA4Key;
					break;
				case kPGPPublicKeyAlgorithm_ECEncrypt:
				case kPGPPublicKeyAlgorithm_ECSign:
					if( revoked )
						iconID = kPGPclImage_ECRevoked;
					else if( expired )
						iconID = kPGPclImage_ECExpired;
					else
						iconID = kPGPclImage_ECKey;
					break;
			}
			break;
		default:
			break;
	}
	if( iconID >= 0 )
		dbImage = [mImages objectAtIndex:iconID];
	return dbImage;
}

- (void)dealloc
{
	sPGPIconsShared = nil;
	[mImages release];
	[super dealloc];
}

@end

