/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.
	
	$Id: CPGPPassphraseTextView.h,v 1.4 2002/08/30 23:38:12 jeffc Exp $
____________________________________________________________________________*/

#import <Cocoa/Cocoa.h>

#include <Carbon/Carbon.h>
#include <PGP/pgpPubTypes.h>

#define kMaxPassphraseLength		255
#define kMaxSpacesPerCharacter		3

@interface CPGPPassphraseTextView : NSTextView
{
	BOOL							mInited;
}

- (id)init;
- (id)initWithFrame:(NSRect)frame;

- (BOOL)becomeFirstResponder;

- (void)clearPassphrase;
- (void)estimateQuality:(NSString*)string;

- (void)flagsChanged:(NSEvent*)event;

- (void)insertText:(id)text;
- (void)superInsertText:(id)text;
- (void)deleteBackward:(id)sender;
- (void)superDeleteBackward:(id)sender;
- (void)setMarkedText:(id)text selectedRange:(NSRange)range;
- (void)insertNewline:(id)sender;
- (void)insertBacktab:(id)sender;
- (void)insertTab:(id)sender;
- (void)moveBackward:(id)sender;
- (void)moveBackwardAndModifySelection:(id)sender;
- (void)moveDown:(id)sender;
- (void)moveDownAndModifySelection:(id)sender;
- (void)moveForward:(id)sender;
- (void)moveForwardAndModifySelection:(id)sender;
- (void)moveLeft:(id)sender;
- (void)moveRight:(id)sender;
- (void)moveToBeginningOfDocument:(id)sender;
- (void)moveToBeginningOfLine:(id)sender;
- (void)moveToBeginningOfParagraph:(id)sender;
- (void)moveToEndOfDocument:(id)sender;
- (void)moveToEndOfLine:(id)sender;
- (void)moveToEndOfParagraph:(id)sender;
- (void)moveUp:(id)sender;
- (void)moveUpAndModifySelection:(id)sender;
- (void)moveWordBackward:(id)sender;
- (void)moveWordBackwardAndModifySelection:(id)sender;
- (void)moveWordForward:(id)sender;
- (void)moveWordForwardAndModifySelection:(id)sender;
- (void)cut:(id)sender;
- (void)copy:(id)sender;
- (void)paste:(id)sender;
- (void)selectAll:(id)sender;

- (void)setSelectedRange:(NSRange)range affinity:(NSSelectionAffinity)affinity stillSelecting:(BOOL)flag;
- (NSRange)selectionRangeForProposedRange:(NSRange)range granularity:(NSSelectionGranularity)granularity;

- (BOOL)validateMenuItem:(id <NSMenuItem>)menuItem;

- (void)dealloc;

@end

@protocol PGPPassphraseViewDelegate

- (BOOL)passphraseView:(CPGPPassphraseTextView*)passphraseView shouldInsertText:(NSString*)string;
- (BOOL)passphraseView:(CPGPPassphraseTextView*)passphraseView shouldDeleteBackward:(id)sender;
- (BOOL)shouldPassphraseViewDisplayMarkedText:(CPGPPassphraseTextView*)passphraseView;

- (void)capsLockStatusDidChange:(BOOL)enabled;

- (void)updatePassphraseQuality:(PGPUInt32)quality sender:(id)sender;

@end
