/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.
	
	$Id: PGPKeyServerDialogs.cpp,v 1.2 2002/08/06 20:10:56 dallen Exp $
____________________________________________________________________________*/

#include "pgpDialogs.h"
#include "PGPDialogProxies.h"

PGPError pgpSearchKeyServerDialogPlatformMain(PGPContextRef context,
	CPGPSearchKeyServerDialogOptions* options)
{
	PGPError					err = kPGPError_NoErr;
	PGPDialogProxyObj			proxy;

	proxy.context = context;	
	proxy.instance = NULL;
	proxy.options = (void*) options;
	proxy.type = kPGPDialogProxyType_SearchKeyServerOptions;

	if (IsPGPError(err = createDialogInstance(&proxy)))
		return err;
	
	err = displayDialog(&proxy);
	
	releaseDialogInstance(&proxy);

	return err;
}

PGPError pgpSendToKeyServerDialogPlatformMain(PGPContextRef context,
	CPGPSendToKeyServerDialogOptions* options)
{
	PGPError					err = kPGPError_NoErr;
	PGPDialogProxyObj			proxy;

	proxy.context = context;	
	proxy.instance = NULL;
	proxy.options = (void*) options;
	proxy.type = kPGPDialogProxyType_SendToKeyServerOptions;

	if (IsPGPError(err = createDialogInstance(&proxy)))
		return err;
	
	err = displayDialog(&proxy);
	
	releaseDialogInstance(&proxy);

	return err;
}