/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.
	
	$Id: PGPPassphraseDialogs.cpp,v 1.2 2002/08/06 20:10:56 dallen Exp $
____________________________________________________________________________*/

#include "pgpDialogs.h"
#include "pgpPassphraseUtils.h"
#include "PGPDialogProxies.h"

	PGPUInt32
PGPEstimatePassphraseQuality(const char *passphrase)
{
	return( pgpEstimatePassphraseQuality( passphrase ) );
}

PGPError pgpPassphraseDialogPlatformMain(PGPContextRef context,
	CPGPPassphraseDialogOptions* options)
{
	PGPError					err = kPGPError_NoErr;
	PGPDialogProxyObj			proxy;

	proxy.context = context;	
	proxy.instance = NULL;
	proxy.options = (void*) options;
	proxy.type = kPGPDialogProxyType_PassphraseOptions;

	if (IsPGPError(err = createDialogInstance(&proxy)))
		return err;
	
	err = displayDialog(&proxy);
	
	releaseDialogInstance(&proxy);

	return err;
}

PGPError pgpKeyPassphraseDialogPlatformMain(PGPContextRef context,
	CPGPKeyPassphraseDialogOptions* options)
{
	PGPError					err = kPGPError_NoErr;
	PGPDialogProxyObj			proxy;
	
	proxy.context = context;
	proxy.instance = NULL;
	proxy.options = (void*) options;
	proxy.type = kPGPDialogProxyType_KeyPassphraseOptions;

	if (IsPGPError(err = createDialogInstance(&proxy)))
		return err;
	
	err = displayDialog(&proxy);
	
	releaseDialogInstance(&proxy);

	return err;
}

PGPError pgpSigningPassphraseDialogPlatformMain(PGPContextRef context,
	CPGPSigningPassphraseDialogOptions* options)
{
	PGPError					err = kPGPError_NoErr;
	PGPDialogProxyObj			proxy;
	
	proxy.context = context;
	proxy.instance = NULL;
	proxy.options = (void*) options;
	proxy.type = kPGPDialogProxyType_SigningPassphraseOptions;

	if (IsPGPError(err = createDialogInstance(&proxy)))
		return err;
	
	err = displayDialog(&proxy);
	
	releaseDialogInstance(&proxy);

	return err;
}

PGPError pgpDecryptionPassphraseDialogPlatformMain(PGPContextRef context,
	CPGPDecryptionPassphraseDialogOptions* options)
{
	PGPError					err = kPGPError_NoErr;
	PGPDialogProxyObj			proxy;

	proxy.context = context;
	proxy.instance = NULL;	
	proxy.options = (void*) options;
	proxy.type = kPGPDialogProxyType_DecryptionPassphraseOptions;

	if (IsPGPError(err = createDialogInstance(&proxy)))
		return err;
	
	err = displayDialog(&proxy);
	
	releaseDialogInstance(&proxy);

	return err;
}

PGPError pgpConfirmationPassphraseDialogPlatformMain(PGPContextRef context,
	CPGPConfirmationPassphraseDialogOptions* options)
{
	PGPError					err = kPGPError_NoErr;
	PGPDialogProxyObj			proxy;

	proxy.context = context;
	proxy.instance = NULL;	
	proxy.options = (void*) options;
	proxy.type = kPGPDialogProxyType_ConfirmationPassphraseOptions;

	if (IsPGPError(err = createDialogInstance(&proxy)))
		return err;
	
	err = displayDialog(&proxy);
	
	releaseDialogInstance(&proxy);

	return err;
}