/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.

	$Id: pgpEC.c,v 1.12.2.1 2002/11/28 07:22:36 ajivsov Exp $
____________________________________________________________________________*/

#include "pgpConfig.h"
#include "pgpSDKPriv.h"

#include "pgpMem.h"
#include "pgpErrors.h"
#include "pgpContext.h"
#include "pgpMemoryMgr.h"
#include "pgpPFLPriv.h"

#include "pgpEC.h"

/* wrappers for ec*. pgpEC* are exported, ec* are not */

PGPError PGPECCreate2mContext( 
	PGPMemoryMgrRef memoryMgr, 
	PGPSize bitsize, PGPECMemoryUsage memUsage, 
	PGPECContextRef *c )  
{
	(void)memoryMgr;
	(void)bitsize;
	(void)memUsage;
	(void)c;
	return kPGPError_FeatureNotAvailable;
}

PGPError PGPECFreeContext( PGPECContextRef c )  {
	(void)c;
	return kPGPError_FeatureNotAvailable;
}

PGPError PGPECSetEC2mParamA( PGPECContextRef c, const unsigned *a )  {
	(void)c;
	(void)a;
	return kPGPError_FeatureNotAvailable;
}

PGPError PGPECSetEC2mParamB( PGPECContextRef c, const unsigned *b )  {
	(void)c;
	(void)b;
	return kPGPError_FeatureNotAvailable;
}

PGPError PGPECSetEC2mParamAInt( PGPECContextRef c, unsigned a )  {
	(void)c;
	(void)a;
	return kPGPError_FeatureNotAvailable;
}

PGPError PGPECSetEC2mParamBInt( PGPECContextRef c, unsigned b )  {
	(void)c;
	(void)b;
	return kPGPError_FeatureNotAvailable;
}

PGPError PGPECGetBufferSize( PGPECContextRef c, 
		PGPSize *coordinateSize,	PGPSize *scalarSize,
		PGPSize *pointDecomprSize,	PGPSize *pointComprSize )	
{
	(void)c;
	(void)coordinateSize;
	(void)scalarSize;
	(void)pointDecomprSize;
	(void)pointComprSize;
	return kPGPError_FeatureNotAvailable;
}


PGPError PGPECScalarCreate( PGPECContextRef c, PGPECScalarRef *s, PGPBoolean isSecure )  {
	(void)c;
	(void)s;
	(void)isSecure;
	return kPGPError_FeatureNotAvailable;
}
PGPError PGPECScalarFree( PGPECScalarRef s )  {
	(void)s;
	return kPGPError_FeatureNotAvailable;
}
PGPError PGPECScalarInsertBytes( PGPECScalarRef s, 
	const PGPByte *scalar /*network order*/, PGPECScalarRef G_ord )
{
	(void)s;
	(void)scalar;
	(void)G_ord;
	return kPGPError_FeatureNotAvailable;
}

PGPError PGPECPointCreate( PGPECContextRef c, PGPECPointRef *p )  {
	(void)c;
	(void)p;
	return kPGPError_FeatureNotAvailable;
}

PGPError PGPECPointFree( PGPECPointRef p )  {
	(void)p;
	return kPGPError_FeatureNotAvailable;
}

PGPError PGPECPointExtractBytes( PGPECPointRef p, PGPByte *out, unsigned flags ) 
{
	(void)p;
	(void)out;
	(void)flags;
	return kPGPError_FeatureNotAvailable;
}

PGPError PGPECPointExtractXYBytes( PGPECPointRef p, PGPByte *out_x, PGPByte *out_y, unsigned flags ) 
{
	(void)p;
	(void)out_x;
	(void)out_y;
	(void)flags;
	return kPGPError_FeatureNotAvailable;
}

PGPError PGPECPointInsertBytes( PGPECPointRef p, 
	   const unsigned char *in, unsigned flags  ) 
{
	(void)p;
	(void)in;
	(void)flags;
	return kPGPError_FeatureNotAvailable;
}

PGPError PGPECPointAssignContext( PGPECPointRef p, PGPECContextRef c )  {
	(void)p;
	(void)c;
	return kPGPError_FeatureNotAvailable;
}

PGPError PGPECPointPrefBasis( PGPECPointRef p )  {
	(void)p;
	return kPGPError_FeatureNotAvailable;
}

PGPError PGPECPointMul( PGPECPointRef p, 
	PGPECScalarRef scalar, 
	PGPBoolean isPrecomputed, /* PGPECPointPrecomp already called */
	PGPECPointRef out )
{
	(void)p;
	(void)scalar;
	(void)isPrecomputed;
	(void)out;
	return kPGPError_FeatureNotAvailable;
}

PGPError PGPECPointAdd( PGPECPointRef p0, const PGPECPointRef p1, PGPECPointRef sum )
{
	(void)p0;
	(void)p1;
	(void)sum;
	return kPGPError_FeatureNotAvailable;
}

PGPError PGPECPointSetZero( PGPECPointRef p ) {
	(void)p;
	return kPGPError_FeatureNotAvailable;
}

PGPBoolean PGPECPointIsZero( PGPECPointRef p ) {
	(void)p;
	return TRUE;
}

PGPBoolean PGPECPointIsConsistent( PGPECPointRef p ) {
	(void)p;
	return FALSE;
}

PGPError PGPECPointCompress( PGPECPointRef p ) {
	(void)p;
	return kPGPError_FeatureNotAvailable;
}

PGPError PGPECPointDecompress( PGPECPointRef p ) {
	(void)p;
	return kPGPError_FeatureNotAvailable;
}
