/*____________________________________________________________________________
        Copyright (C) 2002 PGP Corporation
        All rights reserved.

        $Id: CLDAPPGPKeyServer.h,v 1.6 2002/11/05 00:10:44 dallen Exp $
____________________________________________________________________________*/
#ifndef Included_CLDAPPGPKeyServer_h	/* [ */
#define Included_CLDAPPGPKeyServer_h


#include "pgpSockets.h"
#include "CKeyServer.h"
#include "pgpLDAP.h"
#include "pgpKeyServer.h"


class CLDAPPGPKeyServer : public CKeyServer
{
public:
							CLDAPPGPKeyServer(
								PGPContextRef					inContext,
								const char *					inHostName,
								PGPUInt32						inHostAddress,
								PGPUInt16						inHostPort,
								PGPKeyServerProtocol			inType,
								PGPKeyServerClass				inClass,
								PGPKeyServerAccessType			inAccessType,
								const char *					inKeyStoreDN);
	virtual					~CLDAPPGPKeyServer();
	
	virtual void			Cancel();

	virtual void			Open( PGPtlsSessionRef inTLSSession );
	virtual void			Close();

	virtual void			Query(
								PGPFilterRef		inFilterRef,
								PGPKeyDBRef *		outFoundKeys);
	virtual void			Upload(PGPKeyUploadPreference inSendPrivateKeys,
								PGPKeySetRef inKeysToUpload,
								PGPKeySetRef * outKeysThatFailed);
	virtual void			Delete(PGPKeySetRef inKeysToDelete,
								PGPKeySetRef * outKeysThatFailed);
	virtual void			Disable(PGPKeySetRef inKeysToDelete,
								PGPKeySetRef * outKeysThatFailed);
	virtual void			GetAccessType( PGPKeyServerAccessType &outAccessType )
							{ 
								outAccessType = mAccessType;
							}
	void					GetLDAP( PGPldapContextRef &outLDAP, PGPBoolean &outSecured )
							{
								outLDAP = mLDAP;
								outSecured = mSecured;
							}
	void					SetLDAP( PGPldapContextRef inLDAP, PGPBoolean inSecured )
							{
								mLDAP = inLDAP;
								mSecured = inSecured;
							}
								
protected:
	PGPContextRef			mContext;
	PGPKeyServerAccessType	mAccessType;
	PGPldapContextRef		mLDAP;
	char *					mBaseKeySpaceDN;
	PGPExportFormat			mExportFormat;
	
};



#endif /* ] Included_CLDAPPGPKeyServer_h */


/*__Editor_settings____

	Local Variables:
	tab-width: 4
	End:
	vi: ts=4 sw=4
	vim: si
_____________________*/
