/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.

	$Id: pgpMacFileMapping.h,v 1.5 2002/08/06 20:11:14 dallen Exp $
____________________________________________________________________________*/
#ifndef Included_pgpMacmapping_h	/* [ */
#define Included_pgpMacmapping_h

#include "pgpBase.h"


PGP_BEGIN_C_DECLARATIONS

#if PGP_OSX
#	include <CoreServices/CoreServices.h>
#elif ! PGP_MACINTOSH
	typedef unsigned long	OSType;
#endif

#if PGP_MACINTOSH || PGP_OSX	/* [ */

/* determine if turning off MacBinary is appropriate for this file */
PGPBoolean	pgpOKToEncodeFSSpecWithoutMacBinary( const struct FSSpec *spec );

/* map actual file data into mac creator/type pair */
PGPError	pgpMapFileDataToMacCreatorType( const void *data,
				OSType *creator, OSType *type );
				

/* map file name extension into mac creator/type pair */
/* name is a pascal string */
PGPError	pgpMapFileNameToMacCreatorType( const unsigned char *name,
				OSType *creator, OSType *type );


#endif	/* ] PGP_MACINTOSH */


/* map a creator/type pair to a file name extension */
/* extension is of the form "doc", "bin", etc + null char */
PGPError	pgpMapMacCreatorTypeToExtension( OSType creator, OSType type,
				char	extension[ 3 + 1 ] );

PGPBoolean	pgpIsValidExtensionForMacType( OSType creator, OSType type,
				char const * extension );
				


PGPError	pgpInitMacBinaryMappings( void );
PGPError	pgpDisposeMacBinaryMappings( void );

PGP_END_C_DECLARATIONS



#endif /* ] Included_pgpMacmapping_h */


/*__Editor_settings____

	Local Variables:
	tab-width: 4
	End:
	vi: ts=4 sw=4
	vim: si
_____________________*/
