/*
 * pgpPassCach.h -- A Passphrase Cache
 *
 * Written by:	Derek Atkins <warlord@MIT.EDU>
 *
 * $Id: pgpPassCach.h,v 1.10 2001/11/30 18:50:10 hal Exp $
 */

#ifndef Included_pgpPassCach_h
#define Included_pgpPassCach_h

#include "pgpUsuals.h"

PGP_BEGIN_C_DECLARATIONS

#include "pgpOpaqueStructs.h"
#include "pgpPubTypes.h"
#include "pgpContext.h"


	PGPError
pgpSecKeyUnlockWithCache( PGPSecKey *sec, PGPByte const *passphrase,
	PGPSize passphraseLength, PGPBoolean hashedPhrase, PGPUInt32 cacheTimeOut,
	PGPBoolean cacheGlobal );


	PGPError
pgpSecKeyCachePassphrase( PGPSecKey *sec, PGPByte const *passphrase,
	PGPSize passphraseLength, PGPBoolean hashedPhrase, PGPUInt32 cacheTimeOut,
	PGPBoolean cacheGlobal );

	void
pgpExpirePassphraseCache( PGPContextRef context );

	PGPBoolean
pgpIsPassphraseCached( PGPContextRef context );

	void
pgpPassphraseCacheAddClient( PGPContextRef context, PGPConnectRef id );
	void
pgpPassphraseCacheRemoveClient( PGPConnectRef id );

	PGPError
pgpPurgePassphraseCache_internal( PGPContextRef context );

	PGPError
pgpCountCachedPassphrases_internal( PGPContextRef context,
	PGPUInt32 *pnLocal, PGPUInt32 *pnGlobal, PGPUInt32 *pnOtherLocal );


PGP_END_C_DECLARATIONS

#endif /* Included_pgpPassCach_h */
