/*____________________________________________________________________________
	Copyright (C) 2002 PGP Corporation
	All rights reserved.

	$Id: pgpTest.h,v 1.2 2002/08/06 20:11:17 dallen Exp $
____________________________________________________________________________*/
#ifndef Included_pgpTest_h	/* [ */
#define Included_pgpTest_h


#include "pgpUtilities.h"


#ifndef IsNull
#define IsNull( p )		( (p) == NULL )
#define IsntNull( p )	( (p) != NULL )
#endif

#if PGP_INTERNAL_TESTING

#include "pgpDebug.h"
#include "pgpMem.h"

#define pgpTestAssert( x )			pgpAssert( x )
#define pgpTestDebugMsg( x )		pgpDebugMsg( x )
#define pgpTestAssertNoErr( err )	pgpAssertNoErr( err )


#else

#define	pgpTestAssert( x )	_pgpTestAssert( (PGPBoolean)((x) != 0), #x )
void		_pgpTestAssert( PGPBoolean	condition, const char *expr );
void		pgpTestDebugMsg( const char *msg );
void		pgpTestAssertNoErr( PGPError err );

#undef		pgpFixBeforeShip
#define 	pgpFixBeforeShip( x )	/* nothing */

#endif


PGP_BEGIN_C_DECLARATIONS

void	TestSymmetricCipher( PGPContextRef context );
void	TestCipherFeedback( PGPContextRef context );
void	TestHash( PGPContextRef context );

void	TestKeys( PGPContextRef context );

void	TestLowLevelPublicKey( void );

void	TestEncodeInteractive( PGPContextRef context );
void	TestEncodeCmdLine( PGPContextRef context, const char *commandLine );
void	TestEncodeArgs( PGPContextRef context, int argc, const char **argv );

void	TestMain( void );
PGP_END_C_DECLARATIONS



#endif /* ] Included_pgpTest_h */


/*__Editor_settings____

	Local Variables:
	tab-width: 4
	End:
	vi: ts=4 sw=4
	vim: si
_____________________*/
